;;; This is not meant to be compiled into tool1, it just serves as a
;;; wrapper for games.sc that allows one to load it into the repl

(define (getpid) 1)
(define (getenv x) "x")

(define (pick-up square)
 (when *holding* (message "You are already holding something") (abort))
 (set! *holding* (square-contents square))
 (set-square-contents! square #f)
 (redraw-display-pane))

(define (put-down square)
 (unless *holding* (message "You are not holding anything") (abort))
 (set-square-contents! square *holding*)
 (set! *holding* #f)
 (redraw-display-pane))

(define (clean-up)
 (let ((froms (remove-if-not (lambda (square)
			      (and (square-contents square)
				   (eq? (first (square-name square)) 'board)))
			     *squares*))
       (tos (remove-if-not (lambda (square)
			    (and (not (square-contents square))
				 (eq? (first (square-name square)) 'staging)))
			   *squares*)))
  (for-each (lambda (from to)
	     (pick-up from)
	     (put-down to))
	    froms
	    tos)))

(define *square* #f)
(define *holding* #f)

(load "games.sc")

(eval-when (eval)
  (set! abort
	(lambda ()
	  (*abort-continuation* #f)))

 (set! game 'xo)
 (setup-new-game '(3))
 (generate-game '(3))
 ;;  (set! game 'hexapawn)
 ;;  (hexapawn-setup-new-game '(4)))
 #t)
