/* LaHaShem HaAretz U'Mloah */

#include "tool1lib-c.h"

/* Global Variables */

struct xvimage *vect = NULL;

/* Function Definitions */

/* C int vectors and matrices */

int *make_c_int_vector(int l)
{ int *v;
  v = (int *)malloc(l*sizeof(int));
  if (v==NULL) panic("make_c_int_vector: out of memory.  size = %d", l);
  return v;}

int c_int_vector_ref(int *v, int x) {return v[x];}

void c_int_vector_set(int *v, int x, int i) {v[x] = i;}

void free_c_int_vector(int *v) {free(v);}

int **make_c_int_matrix(int h, int w)
{ int **m, i;
  m = (int **)malloc(h*sizeof(int *));
  if (m==NULL) panic("make_c_int_matrix: out of memory.  size = %d %d", h, w);
  for (i = 0; i<h; i++)
  { m[i] = (int *)malloc(w*sizeof(int));
    if (m[i]==NULL)
    { panic("make_c_int_matrix: out of memory.  size = %d %d", h, w);}}
  return m;}

int c_int_matrix_ref(int **m, int y, int x) {return m[y][x];}

void c_int_matrix_set(int **m, int y, int x, int i) {m[y][x] = i;}

void free_c_int_matrix(int **m, int h)
{ int i;
  for (i = 0; i<h; i++) free(m[i]);
  free(m);}

/* Khoros edge detector */

struct xvimage *create_image(unsigned int height, unsigned int width)
{ return createimage(height, width, VFF_TYP_1_BYTE, 1, 1, "edges", 0, 0,
                     VFF_MS_NONE, VFF_MAPTYP_NONE, VFF_LOC_IMPLICIT, 0);}

void viff_set_pixel(struct xvimage *viff,
		    unsigned int y, unsigned int x, unsigned int grey)
{ unsigned char *array;
  array = (unsigned char *)viff->imagedata;
  array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)] = grey;}

void detect_edges(float a1, float a2, int t1, int t2, int l, int w,
		  struct xvimage *viff)
{ unsigned int x, y;
  unsigned char *array;
  lvdrf(viff, a1, a2, t1, t2, l, w);
  array = (unsigned char *)viff->imagedata;
  for (y = 0; y<(int)viff->col_size; y++)
  { for (x = 0; x<(int)viff->row_size; x++)
    { array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)] =
      array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)]
      <128?0:255;}}}

void detect_line_segments(float a1, float a2, int t1, int t2, int l, int w,
			  struct xvimage *viff)
{ unsigned int x, y;
  unsigned char *array;
  lvdrf(viff, a1, a2, t1, t2, l, w);
  array = (unsigned char *)viff->imagedata;
  for (y = 0; y<(int)viff->col_size; y++)
  { for (x = 0; x<(int)viff->row_size; x++)
    { array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)] =
      array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)]
      <128?0:255;}}
  lvpolygon(viff, &vect, 0.6, 0.1, 10);}

int edge_pixel(struct xvimage *viff, int y, int x)
{ unsigned char *array;
  array = (unsigned char *)viff->imagedata;
  return array[PIXEL(x, y, (int)viff->col_size, (int)viff->row_size)];}

int number_of_line_segments(void) {return vect->col_size;}

int line_segment_x1(int i)
{ int *array;
  array = (int *)vect->imagedata;
  return array[BPIXEL(0, 0, i, (int)vect->col_size, (int)vect->row_size)];}

int line_segment_y1(int i)
{ int *array;
  array = (int *)vect->imagedata;
  return array[BPIXEL(1, 0, i, (int)vect->col_size, (int)vect->row_size)];}

int line_segment_x2(int i)
{ int *array;
  array = (int *)vect->imagedata;
  return array[BPIXEL(2, 0, i, (int)vect->col_size, (int)vect->row_size)];}

int line_segment_y2(int i)
{ int *array;
  array = (int *)vect->imagedata;
  return array[BPIXEL(3, 0, i, (int)vect->col_size, (int)vect->row_size)];}

void free_xvimage(struct xvimage *viff)
{ if (vect!=NULL)
  { free(vect->imagedata);
    free(vect);
    vect = NULL;}
  free(viff->imagedata);
  free(viff);}

/* Interruptible usleep */

int wall_clock(void)
{ struct tms buf;
  return times(&buf);}

/* Tam V'Nishlam Shevah L'El Borei Olam */
