/* LaHaShem HaAretz U'Mloah */

#include "tool1lib-hack-track-c.h"

/* Global Variables */

int gfirst_frame[NCAMERAS], glast_frame[NCAMERAS];
int gobject_k[NCAMERAS][MAX_FRAMES];
float gellipse_x[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
float gellipse_y[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
float gellipse_theta[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
float gellipse_r[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
float gellipse_s[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
int hack_track_camera, hack_track_ncameras;
int hack_track_using_v4l[NCAMERAS];
int hack_track_width[NCAMERAS] = {0, 0, 0, 0} /* debugging */;
int hack_track_height[NCAMERAS];
unsigned char *hack_track_buffer[NCAMERAS];
int hack_track_real_time = FALSE;
int hack_track_uid = -1;
int hack_track_subsample[NCAMERAS];
int hack_track_capturing[NCAMERAS] = {FALSE, FALSE, FALSE, FALSE};
int hack_track_tracking_ellipses[NCAMERAS] = {FALSE, FALSE, FALSE, FALSE};
int hack_track_tracking_polygons[NCAMERAS] = {FALSE, FALSE, FALSE, FALSE};
int hack_track_hull[NCAMERAS];
Display *hack_track_display[NCAMERAS];
int hack_track_screen[NCAMERAS];
Window hack_track_window[NCAMERAS];
int hack_track_window_width[NCAMERAS], hack_track_window_height[NCAMERAS];
int hack_track_window_x[NCAMERAS], hack_track_window_y[NCAMERAS];
int hack_track_i[NCAMERAS], hack_track_n[NCAMERAS];
int hack_track_j[NCAMERAS], hack_track_m[NCAMERAS] = {0, 0, 0, 0};
int hack_track_k[NCAMERAS], hack_track_l[NCAMERAS] = {0, 0, 0, 0};
GC hack_track_gc[NCAMERAS];
XShmSegmentInfo hack_track_shminfo[NCAMERAS];
XImage *hack_track_shmimage[NCAMERAS];
unsigned char *hack_track_frames[NCAMERAS], *hack_track_code_frames[NCAMERAS];
unsigned char *hack_track_last_frame[NCAMERAS];
unsigned char **hack_track_last_code[NCAMERAS];
unsigned char **hack_track_conjure_code[NCAMERAS];
unsigned char **hack_track_last_edge[NCAMERAS];
int hack_track_starting[NCAMERAS], hack_track_conjuring[NCAMERAS];
int hack_track_motion_threshold[NCAMERAS] = {24, 24, 24, 24};
int hack_track_colour_pixel_mass_threshold[NCAMERAS] = {60, 60, 60, 60};
int hack_track_colour_proximity_threshold[NCAMERAS] = {4, 4, 4, 4};
int hack_track_motion_pixel_mass_threshold[NCAMERAS] = {200, 200, 200, 200};
int hack_track_motion_proximity_threshold[NCAMERAS] = {8, 8, 8, 8};
int hack_track_rhl[NCAMERAS] = {336, 336, 336, 336};
int hack_track_rhh[NCAMERAS] = {13, 13, 13, 13};
int hack_track_rsl[NCAMERAS] = {36, 36, 36, 36};
int hack_track_rsh[NCAMERAS] = {74, 74, 74, 74};
int hack_track_rvl[NCAMERAS] = {35, 35, 35, 35};
int hack_track_rvh[NCAMERAS] = {70, 70, 70, 70};
int hack_track_ghl[NCAMERAS] = {122, 122, 122, 122};
int hack_track_ghh[NCAMERAS] = {164, 164, 164, 164};
int hack_track_gsl[NCAMERAS] = {29, 29, 29, 29};
int hack_track_gsh[NCAMERAS] = {71, 71, 71, 71};
int hack_track_gvl[NCAMERAS] = {22, 22, 22, 22};
int hack_track_gvh[NCAMERAS] = {55, 55, 55, 55};
int hack_track_bhl[NCAMERAS] = {192, 192, 192, 192};
int hack_track_bhh[NCAMERAS] = {227, 227, 227, 227};
int hack_track_bsl[NCAMERAS] = {32, 32, 32, 32};
int hack_track_bsh[NCAMERAS] = {66, 66, 66, 66};
int hack_track_bvl[NCAMERAS] = {27, 27, 27, 27};
int hack_track_bvh[NCAMERAS] = {61, 61, 61, 61};
int hack_track_yhl[NCAMERAS] = {50, 50, 50, 50};
int hack_track_yhh[NCAMERAS] = {70, 70, 70, 70};
int hack_track_ysl[NCAMERAS] = {40, 40, 40, 40};
int hack_track_ysh[NCAMERAS] = {65, 65, 65, 65};
int hack_track_yvl[NCAMERAS] = {55, 55, 55, 55};
int hack_track_yvh[NCAMERAS] = {80, 80, 80, 80};
int hack_track_first_frame[NCAMERAS];
int hack_track_last_moving_valid[NCAMERAS], **hack_track_last_moving[NCAMERAS];
int hack_track_interrupts_on = TRUE;
unsigned short hack_track_polygon_l[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
unsigned short hack_track_polygon_x
[NCAMERAS][MAX_FRAMES][MAX_OBJECTS][MAX_VERTICES];
unsigned short hack_track_polygon_y
[NCAMERAS][MAX_FRAMES][MAX_OBJECTS][MAX_VERTICES];
int hack_track_motion[NCAMERAS][MAX_FRAMES];
unsigned char hack_track_object_colour[NCAMERAS][MAX_FRAMES][MAX_OBJECTS];
struct xvimage *hack_track_viff[NCAMERAS];

/* Function Definitions */

void panic(const char *error_text, ...)
{ va_list ap;
  char error_message[1024];
  va_start(ap, error_text);
  vsprintf(error_message, error_text, ap);
  fprintf(stderr, "panic: %s\n", error_message);
  exit(1);}

int get_first_frame(int camera) {return gfirst_frame[camera];}

int get_last_frame(int camera) {return glast_frame[camera];}

int get_object_k(int camera, int frame)
{ return gobject_k[camera][frame];}

float get_ellipse_x(int camera, int frame, int k)
{ return gellipse_x[camera][frame][k];}

float get_ellipse_y(int camera, int frame, int k)
{ return gellipse_y[camera][frame][k];}

float get_ellipse_theta(int camera, int frame, int k)
{ return gellipse_theta[camera][frame][k];}

float get_ellipse_r(int camera, int frame, int k)
{ return gellipse_r[camera][frame][k];}

float get_ellipse_s(int camera, int frame, int k)
{ return gellipse_s[camera][frame][k];}

float my_atan2(float x, float y)
{ if (x==0.0&&y==0.0) return 0.0;
  else if (x==0.0&&y==-1.0) return -PI;
  else return atan2(x, y);}

float quadratic1(float a, float b, float c)
{ float d = b*b-4*a*c;
  if (IS_ZERO(d)&&d<0) d = 0.0;
  return (-b+sqrt(d))/(2*a);}

float quadratic2(float a, float b, float c)
{ float d = b*b-4*a*c;
  if (IS_ZERO(d)&&d<0) d = 0.0;
  return (-b-sqrt(d))/(2*a);}

float eigenvalue1(float xx, float xy, float yx, float yy)
{ return quadratic1(1.0, -(yy+xx), xx*yy-xy*xy);}

float eigenvalue2(float xx, float xy, float yx, float yy)
{ return quadratic2(1.0, -(yy+xx), xx*yy-xy*xy);}

float eigenvector_angle1(float xx, float xy, float yx, float yy)
{ if (IS_ZERO(yx)&&IS_ZERO(xy))
  { if (yy>xx) return PI/2;
    else return 0.0;}
  else return my_atan2(yx, eigenvalue1(xx, xy, yx, yy)-yy);}

float eigenvector_angle2(float xx, float xy, float yx, float yy)
{ if (IS_ZERO(yx)&&IS_ZERO(xy))
  { if (yy<=xx) return PI/2;
    else return 0.0;}
  else return my_atan2(yx, eigenvalue2(xx, xy, yx, yy)-yy);}

int hack_track_get_using_v4l(int camera) {return hack_track_using_v4l[camera];}

int hack_track_get_current_frame(int camera) {return hack_track_i[camera]-1;}

int hack_track_get_motion(int camera, int frame)
{ return hack_track_motion[camera][frame];}

int hack_track_get_object_colour(int camera, int frame, int k)
{ return hack_track_object_colour[camera][frame][k];}

unsigned hack_track_get_polygon_l(int camera, int frame, int k)
{ return hack_track_polygon_l[camera][frame][k];}

unsigned hack_track_get_polygon_x(int camera, int frame, int k, int l)
{ return hack_track_polygon_x[camera][frame][k][l];}

unsigned hack_track_get_polygon_y(int camera, int frame, int k, int l)
{ return hack_track_polygon_y[camera][frame][k][l];}

int hack_track_angle_between(int l, int a, int h)
{ int la, lh;
  la = a-l;
  if (la<0) la += 360;
  lh = h-l;
  if (lh<0) lh += 360;
  return lh>la;}

void hack_track_tracker(int camera,
			unsigned char *buffer,
			int frame,
			int height,
			int width,
			int capturing,
			int capturing_code,
			int tracking_ellipses,
			int tracking_polygons,
			int hull)
/* Global variables:
   hack_track_last_frame[camera]
   hack_track_starting[camera]
   hack_track_{r,g,b}{h,s,v}{l,h}0
   hack_track_last_code[camera]
   hack_track_conjure_code[camera]
   hack_track_conjuring[camera]
   hack_track_code_frames[camera]
   hack_track_polygon_x[camera]
   hack_track_polygon_y[camera]
   hack_track_motion[camera]
   hack_track_object_colour[camera]
   gfirst_frame[camera]
   glast_frame[camera]
   gobject_k[camera]
   gellipse_x[camera]
   gellipse_y[camera]
   gellipse_theta[camera]
   gellipse_r[camera]
   gellipse_s[camera
   */
{ unsigned char *p1, *p2, *p3, *pl;
  int y, x, ymin, ymax, ybest, k, l, r, g, b, rd, gd, bd, h, s, v, p;
  int proximity_threshold;
  int t = hack_track_motion_threshold[camera]*
          hack_track_motion_threshold[camera];
  int i, yp, xp, yl, xl, yh, xh, y1, x1, y2, x2, count, state;
  int j[MAX_OBJECTS];
  int blank = 2;
  int sub_height = height/hack_track_subsample[camera];
  int sub_width = width/hack_track_subsample[camera];
  float mu_x[MAX_OBJECTS], mu_y[MAX_OBJECTS];
  float sigma_xx[MAX_OBJECTS], sigma_xy[MAX_OBJECTS], sigma_yy[MAX_OBJECTS];
  unsigned char colour[MAX_OBJECTS];
  unsigned char code[sub_height][sub_width];
  unsigned char cluster[sub_height][sub_width];
  unsigned char map[sub_height][sub_width];
  short back_y[sub_height][sub_width];
  short back_x[sub_height][sub_width];
  short xmin[height], xmax[height];
  if (capturing)
  /* Copy the current frame from buffer (which holds only the current frame)
     to hack_track_frames[camera] (which holds all of the frames that are
     captured). Only the sampled scan lines are stored to save space. The
     meteor buffer has four bytes per pixel and hack_track_frames[camera] has
     three bytes per pixel (to save space) so packing is done. Two loops are
     needed to allow skipping the nonsampled scan lines. */
  { for (y = 0; y<sub_height; y++)
    { for (p1 = &buffer[hack_track_subsample[camera]*y*width*4],
	   p2 = &hack_track_frames[camera][(frame*sub_height+y)*width*3],
	   pl = &buffer[(hack_track_subsample[camera]*y+1)*width*4];
	   p1<pl;)
      { *p2++ = *p1++;
	*p2++ = *p1++;
	*p2++ = *p1++;
	p1++;}}}
  if (tracking_ellipses||tracking_polygons)
  /* Loop over sampled scan lines. */
  { for (y = 0,
	 p1 = &buffer[0],
	 p2 = &hack_track_last_frame[camera][0],
	 p3 = &code[0][0];
	 y<sub_height;
	 y++,
	 p1 += 4*width*(hack_track_subsample[camera]-1))
    /* Loop over sampled columns. When we subsample vertically, we also
       subsample horizontally to keep things symmetric. */
    { for (x = 0; x<sub_width; x++, p3++)
      /* Get the current pixel in r, g, and b. Get the difference between the
         current pixel in the current frame and the current pixel in the
         previous frame in rd, gd, and bd. Copy the current frame into
         hack_track_last_frame[camera] so that we can do motion detection in
         the next frame. p1 points to the current pixel in the current frame.
         p2 points to the current pixel in the previous frame. */
      { b = *p1++;
	bd = b-*p2;
	*p2++ = b;
	g = *p1++;
	gd = g-*p2;
	*p2++ = g;
	r = *p1++;
	rd = r-*p2;
	*p2++ = r;
	/* Skip the fourth byte and then the nonsampled pixels. */
	p1 += 4*(hack_track_subsample[camera]-1)+1;
	/* Convert RGB to HSV. */
	if (r>g)
	{ if (g>b)
	  { v = 100*r/255;
	    s = r==0?0:(100*(r-b)/r);
	    h = s==0?0:(60*(g-b)/(r-b));}
	  else if (r>b)
	  { v = 100*r/255;
	    s = r==0?0:(100*(r-g)/r);
	    h = s==0?0:(60*(g-b)/(r-g));}
	  else
	  { v = 100*b/255;
	    s = b==0?0:(100*(b-g)/b);
	    h = s==0?0:(240+60*(r-g)/(b-g));}}
	else if (r>b)
	{ v = 100*g/255;
	  s = g==0?0:(100*(g-b)/g);
	  h = s==0?0:(120+60*(b-r)/(g-b));}
	else if (g>b)
	{ v = 100*g/255;
	  s = g==0?0:(100*(g-r)/g);
	  h = s==0?0:(120+60*(b-r)/(g-r));}
	else
	{ v = 100*b/255;
	  s = b==0?0:(100*(b-r)/b);
	  h = s==0?0:(240+60*(r-g)/(b-r));}
	if (h<0) h += 360;
	/* Classify each pixel. The classification of the pixel y,x is in the
           matrix code[y/hack_track_subsample[camera]]
                      [x/hack_track_subsample[camera]].
           p3 points to the current pixel in this matrix. The codes are
           Moving=0, Red=1, Green=2, Blue=3, Yellow=4, other=255. If a pixel
           can be more than one code, it is assigned a unique code in the
           following priority: Red, Green, Blue, Yellow, Moving, other. Note
           that due to subsampling, only sampled rows and columns are stored in
           code. */
	if (hack_track_angle_between(hack_track_rhl[camera],
                                     h,
				     hack_track_rhh[camera])&&
	    s>=hack_track_rsl[camera]&&s<=hack_track_rsh[camera]&&
	    v>=hack_track_rvl[camera]&&v<=hack_track_rvh[camera])
	  *p3 = 1;
	else if (hack_track_angle_between(hack_track_ghl[camera],
					  h,
					  hack_track_ghh[camera])&&
		 s>=hack_track_gsl[camera]&&s<=hack_track_gsh[camera]&&
		 v>=hack_track_gvl[camera]&&v<=hack_track_gvh[camera])
	  *p3 = 2;
	else if (hack_track_angle_between(hack_track_bhl[camera],
					  h,
					  hack_track_bhh[camera])&&
		 s>=hack_track_bsl[camera]&&s<=hack_track_bsh[camera]&&
		 v>=hack_track_bvl[camera]&&v<=hack_track_bvh[camera])
	  *p3 = 3;
	else if (hack_track_angle_between(hack_track_yhl[camera],
					  h,
					  hack_track_yhh[camera])&&
		 s>=hack_track_ysl[camera]&&s<=hack_track_ysh[camera]&&
		 v>=hack_track_yvl[camera]&&v<=hack_track_yvh[camera])
	  *p3 = 4;
	else if (!hack_track_starting[camera]&&rd*rd+gd*gd+bd*bd>=t) *p3 = 0;
	else *p3 = 255;}}
    /* Blanking */
    /* Blanking is an attempt to deal with acretion/deletion. */
    /* This blanks moving pixels that are near coloured pixels. */
    for (y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++)
      if (code[y][x]>=1&&code[y][x]<=4)
      { for (y1 = MAX(y-blank, 0); y1<=y+blank&&y1<sub_height; y1++)
	{ for (x1 = MAX(x-blank, 0); x1<=x+blank&&x1<sub_width; x1++)
	  { if (code[y1][x1]==0) code[y1][x1] = 255;}}}}
    /* This blanks moving pixels that were coloured in the previous frame. */
    if (!hack_track_starting[camera])
    { for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	if (hack_track_last_code[camera][y][x]>=1&&
	    hack_track_last_code[camera][y][x]<=4)
	{ for (y1 = MAX(y-blank, 0); y1<=y+blank&&y1<sub_height; y1++)
	  { for (x1 = MAX(x-blank, 0); x1<=x+blank&&x1<sub_width; x1++)
	    { if (code[y1][x1]==0) code[y1][x1] = 255;}}}}}
    /* Conjuring */
    for (p = 0, y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++) p += (code[y][x]==0);}
    if (p>500&&!hack_track_starting[camera])
    { memcpy(&hack_track_conjure_code[camera][0][0],
	     &code[0][0],
	     sub_height*sub_width);
      hack_track_conjuring[camera] = 5;}
    else if (hack_track_conjuring[camera]>0)
    { hack_track_conjuring[camera]--;
      for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	{ if (hack_track_conjure_code[camera][y][x]==0) code[y][x] = 0;}}}
    hack_track_starting[camera] = FALSE;
    /* This is the proximity clusterer. For each code (Moving, Red, Green,
       Blue, Yellow) form a graph whose vertices are the pixels of that code
       and whose edges connect vertices that are no more than
       proximity_threshold pixels apart both vertically and horizontally.
       There is a separate proximity_threshold for moving and coloured pixels.
       Compute the connected components of each graph. Discard connected
       components with less than pixel_mass_threshold pixels. There is a
       separate pixel_mass_threshold for moving and coloured pixels. Each
       resulting connected component is an object and gets a unique index. The
       index of the object at pixel y,x is in the matrix
       cluster[y/hack_track_subsample[camera]][x/hack_track_subsample[camera]].
       It is 254 or 255 if the pixel does not belong to any object. Note that
       due to subsampling, only sampled rows and columns are stored in cluster.
       The vector colour[k] gives the code, i.e. Moving=0, Red=1, Green=2,
       Blue=3, Yellow=4, for object k. */
    colour[0] = 0;
    k = 0;
    for (y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++) cluster[y][x] = 255;}
    for (i = 0; i<5; i++)
    { proximity_threshold = (i==0?
			     hack_track_motion_proximity_threshold[camera]:
			     hack_track_colour_proximity_threshold[camera])/
			    hack_track_subsample[camera];
      for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	{ if (code[y][x]==i&&cluster[y][x]==255)
	  { cluster[y][x] = k;
	    count = 1;
	    back_y[y][x] = -1;
	    back_x[y][x] = -1;
	    yp = y;
	    xp = x;
	    yl = y;
	    xl = x;
	    yh = y;
	    xh = x;
	    while (yp!=-1)
	    { y1 = yp;
	      x1 = xp;
	      yp = back_y[y1][x1];
	      xp = back_x[y1][x1];
	      if (cluster[y1][x1]==k)
	      { for (y2 = MAX(0, y1-proximity_threshold);
		     y2<sub_height&&y2<=y1+proximity_threshold;
		     y2++)
		{ for (x2 = MAX(0, x1-proximity_threshold);
		       x2<sub_width&&x2<=x1+proximity_threshold;
		       x2++)
		  { if (code[y2][x2]==i&&cluster[y2][x2]==255)
		    { cluster[y2][x2] = k;
		      count++;
		      back_y[y2][x2] = yp;
		      back_x[y2][x2] = xp;
		      yp = y2;
		      xp = x2;
		      yl = MIN(yl, y2);
		      xl = MIN(xl, x2);
		      yh = MAX(yh, y2);
		      xh = MAX(xh, x2);}}}}}
	    if (count>=(i==0?
			hack_track_motion_pixel_mass_threshold[camera]:
			hack_track_colour_pixel_mass_threshold[camera]))
	    { if (k>=MAX_OBJECTS) panic("Too many objects");
	      colour[k] = i;
	      k++;}
	      else
	      { for (y1 = yl; y1<=yh; y1++)
		{ for (x1 = xl; x1<=xh; x1++)
		  if (cluster[y1][x1]==k)
		  { cluster[y1][x1] = 254;
		    code[y1][x1] = 255;}}}}}}}
    memcpy(&hack_track_last_code[camera][0][0],
	   &code[0][0],
	   sub_height*sub_width);
    if (capturing_code)
    { memcpy(&hack_track_code_frames[camera][frame*sub_height*sub_width],
	     &code[0][0],
	     sub_height*sub_width);}}
  if (tracking_ellipses)
  /* For each object k, set mu_x[k] and mu_y[k] to the center of mass of the
     object and set sigma_xx[k], sigma_xy[k], and sigma_yy[k] to the variances
     of the pixel coordinates of object k. */
  { i = k;
    hack_track_motion[camera][frame] = FALSE;
    gobject_k[camera][frame] = k;
    for (k = 0; k<i; k++)
    { j[k] = 0;
      mu_x[k] = 0.0;
      mu_y[k] = 0.0;
      sigma_xx[k] = 0.0;
      sigma_xy[k] = 0.0;
      sigma_yy[k] = 0.0;}
    for (y = 0, p3 = &cluster[0][0]; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++, p3++)
      { k = *p3;
	if (k<254)
	{ j[k]++;
	  mu_x[k] += hack_track_subsample[camera]*x;
	  mu_y[k] += hack_track_subsample[camera]*y;}}}
    for (k = 0; k<i; k++)
    { mu_x[k] /= j[k];
      mu_y[k] /= j[k];}
    for (y = 0, p3 = &cluster[0][0]; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++, p3++)
      { k = *p3;
	if (k<254)
	{ sigma_xx[k] += (hack_track_subsample[camera]*x-mu_x[k])*
	                 (hack_track_subsample[camera]*x-mu_x[k]);
	  sigma_xy[k] += (hack_track_subsample[camera]*x-mu_x[k])*
	                 (hack_track_subsample[camera]*y-mu_y[k]);
	  sigma_yy[k] += (hack_track_subsample[camera]*y-mu_y[k])*
	                 (hack_track_subsample[camera]*y-mu_y[k]);}}}
    /* In frame i, for each object k, set
       hack_track_object_colour[camera][i][k] to
       the object's code, set gellipse_x[camera][i][k] and
       gellipse_y[camera][i][k] to the object's center of mass, set
       gellipse_theta[camera][i][k] to the orientation of the object's major
       axis, set gellipse_r[camera][i][k] and gellipse_s[camera[i][k] to the
       lengths of the object's major and minor axes, and set
       hack_track_motion[camera][i] to TRUE iff there is a moving object in
       that frame. */
    for (k = 0; k<i; k++)
    { sigma_xx[k] /= j[k];
      sigma_xy[k] /= j[k];
      sigma_yy[k] /= j[k];
      hack_track_object_colour[camera][frame][k] = colour[k];
      gellipse_x[camera][frame][k] = mu_x[k];
      gellipse_y[camera][frame][k] = mu_y[k];
      gellipse_theta[camera][frame][k] = eigenvector_angle1(sigma_xx[k],
							    sigma_xy[k],
							    sigma_xy[k],
							    sigma_yy[k]);
      gellipse_r[camera][frame][k] = sqrt(2.0*eigenvalue1(sigma_xx[k],
							  sigma_xy[k],
							  sigma_xy[k],
							  sigma_yy[k]));
      gellipse_s[camera][frame][k] = sqrt(2.0*eigenvalue2(sigma_xx[k],
							  sigma_xy[k],
							  sigma_xy[k],
							  sigma_yy[k]));
      if (colour[k]==0) hack_track_motion[camera][frame] = TRUE;}}
  if (tracking_polygons)
  { i = k;
    hack_track_motion[camera][frame] = FALSE;
    gobject_k[camera][frame] = k;
    for (k = 0; k<i; k++)
    { hack_track_object_colour[camera][frame][k] = colour[k];
      if (hull)
      /* Compute the convex hull of object k. The top of the object is ymin
         and the bottom of the object is ymax. For each sampled scan line y
         xmin[y/hack_track_subsample[camera]] is the leftmost pixel in the
         object and xmax[y/hack_track_subsample[camera]] is the rightmost
         pixel. Due to subsampling, only sampled columns are stored in xmin and
         xmax. */
      { ymin = height;
	ymax = -1;
	for (y = 0; y<sub_height; y++)
	{ xmin[y] = width;
	  xmax[y] = -1;
	  for (x = 0; x<sub_width; x++)
	  { if (cluster[y][x]==k)
	    { ymin = MIN(ymin, hack_track_subsample[camera]*y);
	      ymax = MAX(ymax, hack_track_subsample[camera]*y);
	      xmin[y] = MIN(xmin[y], hack_track_subsample[camera]*x);
	      xmax[y] = MAX(xmax[y], hack_track_subsample[camera]*x);}}}
	l = 0;
	/* Go from top to bottom down the right side of the object, splicing
           out concavities. */
	for (ybest = ymin/hack_track_subsample[camera];
	     ybest<=ymax/hack_track_subsample[camera]&&xmax[ybest]==-1;
	     ybest++);
	while (ybest<=ymax/hack_track_subsample[camera]&&ybest!=-1)
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  hack_track_polygon_y[camera][frame][k][l] =
	    hack_track_subsample[camera]*ybest;
	  hack_track_polygon_x[camera][frame][k][l] = xmax[ybest];
	  l++;
	  p = FALSE;
	  for (y = hack_track_polygon_y[camera][frame][k][l-1]/
		   hack_track_subsample[camera]+1;
	       y<=ymax/hack_track_subsample[camera];
	       y++)
	  { if (xmax[y]!=-1&&
		xmax[y]>=hack_track_polygon_x[camera][frame][k][l-1])
            { p = TRUE;}}
	  ybest = -1;
	  for (y = hack_track_polygon_y[camera][frame][k][l-1]/
		   hack_track_subsample[camera]+1;
	       y<=ymax/hack_track_subsample[camera];
	       y++)
	  { if (xmax[y]!=-1&&
		(!p||xmax[y]>=hack_track_polygon_x[camera][frame][k][l-1])&&
		(ybest==-1||
		 (hack_track_polygon_x[camera][frame][k][l-1]-xmax[ybest])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*y)<
		 (hack_track_polygon_x[camera][frame][k][l-1]-xmax[y])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*ybest)))
	    { ybest = y;}}}
	/* Go from bottom to top up the left side of the object, splicing out
           concavities. */
	for (ybest = ymax/hack_track_subsample[camera];
	     ybest>=ymin/hack_track_subsample[camera]&&xmin[ybest]==-1;
	     ybest--);
	while (ybest>=ymin/hack_track_subsample[camera]&&ybest!=-1)
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  hack_track_polygon_y[camera][frame][k][l] =
	    hack_track_subsample[camera]*ybest;
	  hack_track_polygon_x[camera][frame][k][l] = xmin[ybest];
	  l++;
	  p = FALSE;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1;
	       y>=ymin/hack_track_subsample[camera];
	       y--)
	  { if (xmin[y]!=-1&&
		xmin[y]<=hack_track_polygon_x[camera][frame][k][l-1])
            { p = TRUE;}}
	  ybest = -1;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1;
	       y>=ymin/hack_track_subsample[camera];
	       y--)
	  { if (xmin[y]!=-1&&
		(!p||xmin[y]<=hack_track_polygon_x[camera][frame][k][l-1])&&
		(ybest==-1||
		 (xmin[ybest]-hack_track_polygon_x[camera][frame][k][l-1])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*y)>
		 (xmin[y]-hack_track_polygon_x[camera][frame][k][l-1])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*ybest)))
	    { ybest = y;}}}}
      else
      /* Compute the contour of the object. */
      { proximity_threshold = (colour[k]==0?
			       hack_track_motion_proximity_threshold[camera]:
			       hack_track_colour_proximity_threshold[camera])/
			      hack_track_subsample[camera];
	/* Copy the pixels from cluster that correspond to object k into map.
           */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { map[y][x] = (cluster[y][x]==k);}}
	/* Bloat map by the proximity threshold. If there are two pixels in
           map that are separated by less than proximity_threshold both
           vertically and horizontally then fill in the bounding rectangle of
           those two pixels. */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { if (cluster[y][x]==k)
	    { for (y1 = MAX(0, y-proximity_threshold);
		   y1<sub_height&&y1<=y+proximity_threshold;
		   y1++)
	      { for (x1 = MAX(0, x-proximity_threshold);
		     x1<sub_width&&x1<=x+proximity_threshold;
		     x1++)
		{ if (cluster[y1][x1]==k)
		  { for (y2 = MIN(y, y1); y2<=MAX(y, y1); y2++)
		    { for (x2 = MIN(x, x1); x2<=MAX(x, x1); x2++)
		      { map[y2][x2] = TRUE;}}}}}}}}
	/* This is a contour follower. */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { if (map[y][x])
	    { hack_track_polygon_y[camera][frame][k][0] =
		hack_track_subsample[camera]*y;
	      hack_track_polygon_x[camera][frame][k][0] =
		hack_track_subsample[camera]*x;
	      goto l1;}}}
	panic("This shouldn't happen");
	l1:
	if (hack_track_polygon_x[camera][frame][k][0]<
	    width-hack_track_subsample[camera]&&
	    map[hack_track_polygon_y[camera][frame][k][0]/
		hack_track_subsample[camera]]
	    [hack_track_polygon_x[camera][frame][k][0]/
	     hack_track_subsample[camera]+1])
	{ hack_track_polygon_y[camera][frame][k][1] =
	    hack_track_polygon_y[camera][frame][k][0];
	  hack_track_polygon_x[camera][frame][k][1] =
	    hack_track_polygon_x[camera][frame][k][0]+
	    hack_track_subsample[camera];
	  state = 0;}
	else if (hack_track_polygon_y[camera][frame][k][0]<
		 height-hack_track_subsample[camera]&&
		 map
		 [hack_track_polygon_y[camera][frame][k][0]/
		  hack_track_subsample[camera]+1]
		 [hack_track_polygon_x[camera][frame][k][0]/
		  hack_track_subsample[camera]])
	{ hack_track_polygon_y[camera][frame][k][1] =
	    hack_track_polygon_y[camera][frame][k][0]+
	    hack_track_subsample[camera];
	  hack_track_polygon_x[camera][frame][k][1] =
	    hack_track_polygon_x[camera][frame][k][0];
	  state = 3;}
	else panic("This shouldn't happen");
	l = 2;
	l2:
	if (hack_track_polygon_y[camera][frame][k][l-1]!=
	    hack_track_polygon_y[camera][frame][k][0]||
	    hack_track_polygon_x[camera][frame][k][l-1]!=
	    hack_track_polygon_x[camera][frame][k][0])
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  switch (state)
	  { case 0:
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 1:
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 2:
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 3:
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");}}}
      hack_track_polygon_l[camera][frame][k] = l;
      if (colour[k]==0) hack_track_motion[camera][frame] = TRUE;}}}

void hack_track_new_tracker(int camera,
			    unsigned char *buffer,
			    int frame,
			    int height,
			    int width,
			    int capturing,
			    int capturing_code,
			    int tracking_ellipses,
			    int tracking_polygons,
			    int hull)
/* Global variables:
   hack_track_starting[camera]
   hack_track_{r,g,b}{h,s,v}{l,h}0
   hack_track_last_code[camera]
   hack_track_conjure_code[camera]
   hack_track_conjuring[camera]
   hack_track_code_frames[camera]
   hack_track_polygon_x[camera]
   hack_track_polygon_y[camera]
   hack_track_motion[camera]
   hack_track_object_colour[camera]
   gfirst_frame[camera]
   glast_frame[camera]
   gobject_k[camera]
   gellipse_x[camera]
   gellipse_y[camera]
   gellipse_theta[camera]
   gellipse_r[camera]
   gellipse_s[camera
   */
{ unsigned char *p1, *p2, *pl;
  int y, x, ymin, ymax, ybest, k, l, r, g, b, h, s, v, p;
  int proximity_threshold;
  int i, yp, xp, yl, xl, yh, xh, y1, x1, y2, x2, count, state;
  int j[MAX_OBJECTS];
  int blank = 2;
  int sub_height = height/hack_track_subsample[camera];
  int sub_width = width/hack_track_subsample[camera];
  float mu_x[MAX_OBJECTS], mu_y[MAX_OBJECTS];
  float sigma_xx[MAX_OBJECTS], sigma_xy[MAX_OBJECTS], sigma_yy[MAX_OBJECTS];
  unsigned char colour[MAX_OBJECTS];
  unsigned char code[sub_height][sub_width];
  unsigned char cluster[sub_height][sub_width];
  unsigned char map[sub_height][sub_width];
  unsigned char motion[sub_height][sub_width];
  unsigned char *array;
  short back_y[sub_height][sub_width];
  short back_x[sub_height][sub_width];
  short xmin[height], xmax[height];
  if (capturing)
  /* Copy the current frame from buffer (which holds only the current frame)
     to hack_track_frames[camera] (which holds all of the frames that are
     captured). Only the sampled scan lines are stored to save space. The
     meteor buffer has four bytes per pixel and hack_track_frames[camera] has
     three bytes per pixel (to save space) so packing is done. Two loops are
     needed to allow skipping the nonsampled scan lines. */
  { for (y = 0; y<sub_height; y++)
    { for (p1 = &buffer[hack_track_subsample[camera]*y*width*4],
	   p2 = &hack_track_frames[camera][(frame*sub_height+y)*width*3],
	   pl = &buffer[(hack_track_subsample[camera]*y+1)*width*4];
	   p1<pl;)
      { *p2++ = *p1++;
	*p2++ = *p1++;
	*p2++ = *p1++;
	p1++;}}}
  if (tracking_ellipses||tracking_polygons)
  /* Loop over sampled scan lines.
     Convert the image into grey scale, storing the result in array. Then
     compute the edge map, storing the result in array. Save the previous
     thresholded edge map in hack_track_last_edge[camera]. */
  { array = (unsigned char *)hack_track_viff[camera]->imagedata;
    for (y = 0, p1 = &buffer[0];
         y<sub_height;
         y++, p1 += 4*width*(hack_track_subsample[camera]-1))
    { for (x = 0; x<sub_width; x++)
      { b = *p1++;
	g = *p1++;
	r = *p1++;
	/* Skip the fourth byte and then the nonsampled pixels. */
	p1 += 4*(hack_track_subsample[camera]-1)+1;
        hack_track_last_edge[camera][y][x] =
          array[PIXEL(x, y, sub_height, sub_width)]>128?255:0;
        array[PIXEL(x, y, sub_height, sub_width)] = 0.299*r+0.587*g+0.114*b;}}
    lvdrf(hack_track_viff[camera], 0.3, 0.3, 12, 15, 10, 5);
    array = (unsigned char *)hack_track_viff[camera]->imagedata;
    /* Bloat the previous thresholded edge map by one pixel in each of the
       eight directions and use it to mask the current tresholded edge map.
       Store the result in motion*/
    for (y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++)
      { motion[y][x] =
          (array[PIXEL(x, y, sub_height, sub_width)]>128?255:0)&
          !(hack_track_last_edge[camera][MAX(y-1,0)][MAX(x-1,0)]|
            hack_track_last_edge[camera][MAX(y-1,0)][x]|
            hack_track_last_edge[camera][MAX(y-1,0)][MIN(x+1,sub_width-1)]|
            hack_track_last_edge[camera][y][MAX(x-1,0)]|
            hack_track_last_edge[camera][y][x]|
            hack_track_last_edge[camera][y][MIN(x+1,sub_width-1)]|
            hack_track_last_edge[camera][MIN(y+1,sub_height-1)][MAX(x-1,0)]|
            hack_track_last_edge[camera][MIN(y+1,sub_height-1)][x]|
            hack_track_last_edge[camera][MIN(y+1,sub_height-1)]
                                [MIN(x+1,sub_width-1)]);}}
    for (y = 0,
	 p1 = &buffer[0],
	 p2 = &code[0][0];
	 y<sub_height;
	 y++,
	 p1 += 4*width*(hack_track_subsample[camera]-1))
    /* Loop over sampled columns. When we subsample vertically, we also
       subsample horizontally to keep things symmetric. */
    { for (x = 0; x<sub_width; x++, p2++)
      /* Get the current pixel in r, g, and b. Get the difference between the
         current pixel in the current frame and the current pixel in the
         previous frame in rd, gd, and bd. p1 points to the current pixel in
         the current frame. */
      { b = *p1++;
	g = *p1++;
	r = *p1++;
	/* Skip the fourth byte and then the nonsampled pixels. */
	p1 += 4*(hack_track_subsample[camera]-1)+1;
	/* Convert RGB to HSV. */
	if (r>g)
	{ if (g>b)
	  { v = 100*r/255;
	    s = r==0?0:(100*(r-b)/r);
	    h = s==0?0:(60*(g-b)/(r-b));}
	  else if (r>b)
	  { v = 100*r/255;
	    s = r==0?0:(100*(r-g)/r);
	    h = s==0?0:(60*(g-b)/(r-g));}
	  else
	  { v = 100*b/255;
	    s = b==0?0:(100*(b-g)/b);
	    h = s==0?0:(240+60*(r-g)/(b-g));}}
	else if (r>b)
	{ v = 100*g/255;
	  s = g==0?0:(100*(g-b)/g);
	  h = s==0?0:(120+60*(b-r)/(g-b));}
	else if (g>b)
	{ v = 100*g/255;
	  s = g==0?0:(100*(g-r)/g);
	  h = s==0?0:(120+60*(b-r)/(g-r));}
	else
	{ v = 100*b/255;
	  s = b==0?0:(100*(b-r)/b);
	  h = s==0?0:(240+60*(r-g)/(b-r));}
	if (h<0) h += 360;
	/* Classify each pixel. The classification of the pixel y,x is in the
           matrix code[y/hack_track_subsample[camera]]
	              [x/hack_track_subsample[camera]].
           p2 points to the current pixel in this matrix. The codes are
           Moving=0, Red=1, Green=2, Blue=3, Yellow=4, other=255. If a pixel
           can be more than one code, it is assigned a unique code in the
           following priority: Red, Green, Blue, Yellow, Moving, other. Note
           that due to subsampling, only sampled rows and columns are stored in
           code. */
	if (hack_track_angle_between(hack_track_rhl[camera],
				     h,
				     hack_track_rhh[camera])&&
	    s>=hack_track_rsl[camera]&&s<=hack_track_rsh[camera]&&
	    v>=hack_track_rvl[camera]&&v<=hack_track_rvh[camera])
	  *p2 = 1;
	else if (hack_track_angle_between(hack_track_ghl[camera],
					  h,
					  hack_track_ghh[camera])&&
		 s>=hack_track_gsl[camera]&&s<=hack_track_gsh[camera]&&
		 v>=hack_track_gvl[camera]&&v<=hack_track_gvh[camera])
	  *p2 = 2;
	else if (hack_track_angle_between(hack_track_bhl[camera],
					  h,
					  hack_track_bhh[camera])&&
		 s>=hack_track_bsl[camera]&&s<=hack_track_bsh[camera]&&
		 v>=hack_track_bvl[camera]&&v<=hack_track_bvh[camera])
	  *p2 = 3;
	else if (hack_track_angle_between(hack_track_yhl[camera],
					  h,
					  hack_track_yhh[camera])&&
		 s>=hack_track_ysl[camera]&&s<=hack_track_ysh[camera]&&
		 v>=hack_track_yvl[camera]&&v<=hack_track_yvh[camera])
	  *p2 = 4;
	else if (!hack_track_starting[camera]&&motion[y][x]) *p2 = 0;
	else *p2 = 255;}}
    /* Blanking */
    /* Blanking is an attempt to deal with acretion/deletion. */
    /* This blanks moving pixels that are near coloured pixels. */
    for (y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++)
      if (code[y][x]>=1&&code[y][x]<=4)
      { for (y1 = MAX(y-blank, 0); y1<=y+blank&&y1<sub_height; y1++)
	{ for (x1 = MAX(x-blank, 0); x1<=x+blank&&x1<sub_width; x1++)
	  { if (code[y1][x1]==0) code[y1][x1] = 255;}}}}
    /* This blanks moving pixels that were coloured in the previous frame. */
    if (!hack_track_starting[camera])
    { for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	if (hack_track_last_code[camera][y][x]>=1&&
	    hack_track_last_code[camera][y][x]<=4)
	{ for (y1 = MAX(y-blank, 0); y1<=y+blank&&y1<sub_height; y1++)
	  { for (x1 = MAX(x-blank, 0); x1<=x+blank&&x1<sub_width; x1++)
	    { if (code[y1][x1]==0) code[y1][x1] = 255;}}}}}
    /* Conjuring */
    for (p = 0, y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++) p += (code[y][x]==0);}
    if (p>500&&!hack_track_starting[camera])
    { memcpy(&hack_track_conjure_code[camera][0][0],
	     &code[0][0],
	     sub_height*sub_width);
      hack_track_conjuring[camera] = 5;}
    else if (hack_track_conjuring[camera]>0)
    { hack_track_conjuring[camera]--;
      for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	{ if (hack_track_conjure_code[camera][y][x]==0) code[y][x] = 0;}}}
    hack_track_starting[camera] = FALSE;
    /* This is the proximity clusterer. For each code (Moving, Red, Green,
       Blue, Yellow) form a graph whose vertices are the pixels of that code
       and whose edges connect vertices that are no more than
       proximity_threshold pixels apart both vertically and horizontally.
       There is a separate proximity_threshold for moving and coloured pixels.
       Compute the connected components of each graph. Discard connected
       components with less than pixel_mass_threshold pixels. There is a
       separate pixel_mass_threshold for moving and coloured pixels. Each
       resulting connected component is an object and gets a unique index. The
       index of the object at pixel y,x is in the matrix
       cluster[y/hack_track_subsample[camera]][x/hack_track_subsample[camera]].
       It is 254 or 255 if the pixel does not belong to any object. Note that
       due to subsampling, only sampled rows and columns are stored in cluster.
       The vector colour[k] gives the code, i.e. Moving=0, Red=1, Green=2,
       Blue=3, Yellow=4, for object k. */
    colour[0] = 0;
    k = 0;
    for (y = 0; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++) cluster[y][x] = 255;}
    for (i = 0; i<5; i++)
    { proximity_threshold = (i==0?
			     hack_track_motion_proximity_threshold[camera]:
			     hack_track_colour_proximity_threshold[camera])/
			    hack_track_subsample[camera];
      for (y = 0; y<sub_height; y++)
      { for (x = 0; x<sub_width; x++)
	{ if (code[y][x]==i&&cluster[y][x]==255)
	  { cluster[y][x] = k;
	    count = 1;
	    back_y[y][x] = -1;
	    back_x[y][x] = -1;
	    yp = y;
	    xp = x;
	    yl = y;
	    xl = x;
	    yh = y;
	    xh = x;
	    while (yp!=-1)
	    { y1 = yp;
	      x1 = xp;
	      yp = back_y[y1][x1];
	      xp = back_x[y1][x1];
	      if (cluster[y1][x1]==k)
	      { for (y2 = MAX(0, y1-proximity_threshold);
		     y2<sub_height&&y2<=y1+proximity_threshold;
		     y2++)
		{ for (x2 = MAX(0, x1-proximity_threshold);
		       x2<sub_width&&x2<=x1+proximity_threshold;
		       x2++)
		  { if (code[y2][x2]==i&&cluster[y2][x2]==255)
		    { cluster[y2][x2] = k;
		      count++;
		      back_y[y2][x2] = yp;
		      back_x[y2][x2] = xp;
		      yp = y2;
		      xp = x2;
		      yl = MIN(yl, y2);
		      xl = MIN(xl, x2);
		      yh = MAX(yh, y2);
		      xh = MAX(xh, x2);}}}}}
	    if (count>=(i==0?
			hack_track_motion_pixel_mass_threshold[camera]:
			hack_track_colour_pixel_mass_threshold[camera]))
	    { if (k>=MAX_OBJECTS) panic("Too many objects");
	      colour[k] = i;
	      k++;}
	      else
	      { for (y1 = yl; y1<=yh; y1++)
		{ for (x1 = xl; x1<=xh; x1++)
		  if (cluster[y1][x1]==k)
		  { cluster[y1][x1] = 254;
		    code[y1][x1] = 255;}}}}}}}
    memcpy(&hack_track_last_code[camera][0][0],
	   &code[0][0],
	   sub_height*sub_width);
    if (capturing_code)
    { memcpy(&hack_track_code_frames[camera][frame*sub_height*sub_width],
	     &code[0][0],
	     sub_height*sub_width);}}
  if (tracking_ellipses)
  /* For each object k, set mu_x[k] and mu_y[k] to the center of mass of the
     object and set sigma_xx[k], sigma_xy[k], and sigma_yy[k] to the variances
     of the pixel coordinates of object k. */
  { i = k;
    hack_track_motion[camera][frame] = FALSE;
    gobject_k[camera][frame] = k;
    for (k = 0; k<i; k++)
    { j[k] = 0;
      mu_x[k] = 0.0;
      mu_y[k] = 0.0;
      sigma_xx[k] = 0.0;
      sigma_xy[k] = 0.0;
      sigma_yy[k] = 0.0;}
    for (y = 0, p2 = &cluster[0][0]; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++, p2++)
      { k = *p2;
	if (k<254)
	{ j[k]++;
	  mu_x[k] += hack_track_subsample[camera]*x;
	  mu_y[k] += hack_track_subsample[camera]*y;}}}
    for (k = 0; k<i; k++)
    { mu_x[k] /= j[k];
      mu_y[k] /= j[k];}
    for (y = 0, p2 = &cluster[0][0]; y<sub_height; y++)
    { for (x = 0; x<sub_width; x++, p2++)
      { k = *p2;
	if (k<254)
	{ sigma_xx[k] += (hack_track_subsample[camera]*x-mu_x[k])*
	                 (hack_track_subsample[camera]*x-mu_x[k]);
	  sigma_xy[k] += (hack_track_subsample[camera]*x-mu_x[k])*
	                 (hack_track_subsample[camera]*y-mu_y[k]);
	  sigma_yy[k] += (hack_track_subsample[camera]*y-mu_y[k])*
	                 (hack_track_subsample[camera]*y-mu_y[k]);}}}
    /* In frame i, for each object k, set
       hack_track_object_colour[camera][i][k] to
       the object's code, set gellipse_x[camera][i][k] and
       gellipse_y[camera][i][k] to the object's center of mass, set
       gellipse_theta[camera][i][k] to the orientation of the object's major
       axis, set gellipse_r[camera][i][k] and gellipse_s[camera[i][k] to the
       lengths of the object's major and minor axes, and set
       hack_track_motion[camera][i] to TRUE iff there is a moving object in
       that frame. */
    for (k = 0; k<i; k++)
    { sigma_xx[k] /= j[k];
      sigma_xy[k] /= j[k];
      sigma_yy[k] /= j[k];
      hack_track_object_colour[camera][frame][k] = colour[k];
      gellipse_x[camera][frame][k] = mu_x[k];
      gellipse_y[camera][frame][k] = mu_y[k];
      gellipse_theta[camera][frame][k] = eigenvector_angle1(sigma_xx[k],
							    sigma_xy[k],
							    sigma_xy[k],
							    sigma_yy[k]);
      gellipse_r[camera][frame][k] = sqrt(2.0*eigenvalue1(sigma_xx[k],
							  sigma_xy[k],
							  sigma_xy[k],
							  sigma_yy[k]));
      gellipse_s[camera][frame][k] = sqrt(2.0*eigenvalue2(sigma_xx[k],
							  sigma_xy[k],
							  sigma_xy[k],
							  sigma_yy[k]));
      if (colour[k]==0) hack_track_motion[camera][frame] = TRUE;}}
  if (tracking_polygons)
  { i = k;
    hack_track_motion[camera][frame] = FALSE;
    gobject_k[camera][frame] = k;
    for (k = 0; k<i; k++)
    { hack_track_object_colour[camera][frame][k] = colour[k];
      if (hull)
      /* Compute the convex hull of object k. The top of the object is ymin
         and the bottom of the object is ymax. For each sampled scan line y
         xmin[y/hack_track_subsample[camera]] is the leftmost pixel in the
         object and xmax[y/hack_track_subsample[camera]] is the rightmost
	 pixel. Due to subsampling, only sampled columns are stored in xmin and
	 xmax. */
      { ymin = height;
	ymax = -1;
	for (y = 0; y<sub_height; y++)
	{ xmin[y] = width;
	  xmax[y] = -1;
	  for (x = 0; x<sub_width; x++)
	  { if (cluster[y][x]==k)
	    { ymin = MIN(ymin, hack_track_subsample[camera]*y);
	      ymax = MAX(ymax, hack_track_subsample[camera]*y);
	      xmin[y] = MIN(xmin[y], hack_track_subsample[camera]*x);
	      xmax[y] = MAX(xmax[y], hack_track_subsample[camera]*x);}}}
	l = 0;
	/* Go from top to bottom down the right side of the object, splicing
           out concavities. */
	for (ybest = ymin/hack_track_subsample[camera];
	     ybest<=ymax/hack_track_subsample[camera]&&xmax[ybest]==-1;
	     ybest++);
	while (ybest<=ymax/hack_track_subsample[camera]&&ybest!=-1)
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  hack_track_polygon_y[camera][frame][k][l] =
	    hack_track_subsample[camera]*ybest;
	  hack_track_polygon_x[camera][frame][k][l] = xmax[ybest];
	  l++;
	  p = FALSE;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1;
	       y<=ymax/hack_track_subsample[camera];
	       y++)
	  { if (xmax[y]!=-1&&
		xmax[y]>=hack_track_polygon_x[camera][frame][k][l-1])
	    p = TRUE;}
	  ybest = -1;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1;
	       y<=ymax/hack_track_subsample[camera];
	       y++)
	  { if (xmax[y]!=-1&&
		(!p||xmax[y]>=hack_track_polygon_x[camera][frame][k][l-1])&&
		(ybest==-1||
		 (hack_track_polygon_x[camera][frame][k][l-1]-xmax[ybest])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*y)<
		 (hack_track_polygon_x[camera][frame][k][l-1]-xmax[y])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*ybest)))
	    ybest = y;}}
	/* Go from bottom to top up the left side of the object, splicing out
           concavities. */
	for (ybest = ymax/hack_track_subsample[camera];
	     ybest>=ymin/hack_track_subsample[camera]&&xmin[ybest]==-1;
	     ybest--);
	while (ybest>=ymin/hack_track_subsample[camera]&&ybest!=-1)
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  hack_track_polygon_y[camera][frame][k][l] =
	    hack_track_subsample[camera]*ybest;
	  hack_track_polygon_x[camera][frame][k][l] = xmin[ybest];
	  l++;
	  p = FALSE;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1;
	       y>=ymin/hack_track_subsample[camera];
	       y--)
	  { if (xmin[y]!=-1&&
		xmin[y]<=hack_track_polygon_x[camera][frame][k][l-1])
	    p = TRUE;}
	  ybest = -1;
	  for (y =
		 hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1;
	       y>=ymin/hack_track_subsample[camera];
	       y--)
	  { if (xmin[y]!=-1&&
		(!p||xmin[y]<=hack_track_polygon_x[camera][frame][k][l-1])&&
		(ybest==-1||
		 (xmin[ybest]-hack_track_polygon_x[camera][frame][k][l-1])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*y)>
		 (xmin[y]-hack_track_polygon_x[camera][frame][k][l-1])*
		 (hack_track_polygon_y[camera][frame][k][l-1]-
		  hack_track_subsample[camera]*ybest)))
	    ybest = y;}}}
      else
      /* Compute the contour of the object. */
      { proximity_threshold = (colour[k]==0?
			       hack_track_motion_proximity_threshold[camera]:
			       hack_track_colour_proximity_threshold[camera])/
			      hack_track_subsample[camera];
	/* Copy the pixels from cluster that correspond to object k into map.
           */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { map[y][x] = (cluster[y][x]==k);}}
	/* Bloat map by the proximity threshold. If there are two pixels in
           map that are separated by less than proximity_threshold both
           vertically and horizontally then fill in the bounding rectangle of
           those two pixels. */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { if (cluster[y][x]==k)
	    { for (y1 = MAX(0, y-proximity_threshold);
		   y1<sub_height&&y1<=y+proximity_threshold;
		   y1++)
	      { for (x1 = MAX(0, x-proximity_threshold);
		     x1<sub_width&&x1<=x+proximity_threshold;
		     x1++)
		{ if (cluster[y1][x1]==k)
		  { for (y2 = MIN(y, y1); y2<=MAX(y, y1); y2++)
		    { for (x2 = MIN(x, x1); x2<=MAX(x, x1); x2++)
		      { map[y2][x2] = TRUE;}}}}}}}}
	/* This is a contour follower. */
	for (y = 0; y<sub_height; y++)
	{ for (x = 0; x<sub_width; x++)
	  { if (map[y][x])
	    { hack_track_polygon_y[camera][frame][k][0] =
		hack_track_subsample[camera]*y;
	      hack_track_polygon_x[camera][frame][k][0] =
		hack_track_subsample[camera]*x;
	      goto l1;}}}
	panic("This shouldn't happen");
	l1:
	if (hack_track_polygon_x[camera][frame][k][0]<
	    width-hack_track_subsample[camera]&&
	    map[hack_track_polygon_y[camera][frame][k][0]/
		hack_track_subsample[camera]]
	    [hack_track_polygon_x[camera][frame][k][0]/
	     hack_track_subsample[camera]+1])
	{ hack_track_polygon_y[camera][frame][k][1] =
	    hack_track_polygon_y[camera][frame][k][0];
	  hack_track_polygon_x[camera][frame][k][1] =
	    hack_track_polygon_x[camera][frame][k][0]+
	    hack_track_subsample[camera];
	  state = 0;}
	else if (hack_track_polygon_y[camera][frame][k][0]<
		 height-hack_track_subsample[camera]&&
		 map
		 [hack_track_polygon_y[camera][frame][k][0]/
		  hack_track_subsample[camera]+1]
		 [hack_track_polygon_x[camera][frame][k][0]/
		  hack_track_subsample[camera]])
	{ hack_track_polygon_y[camera][frame][k][1] =
	    hack_track_polygon_y[camera][frame][k][0]+
	    hack_track_subsample[camera];
	  hack_track_polygon_x[camera][frame][k][1] =
	    hack_track_polygon_x[camera][frame][k][0];
	  state = 3;}
	else panic("This shouldn't happen");
	l = 2;
	l2:
	if (hack_track_polygon_y[camera][frame][k][l-1]!=
	    hack_track_polygon_y[camera][frame][k][0]||
	    hack_track_polygon_x[camera][frame][k][l-1]!=
	    hack_track_polygon_x[camera][frame][k][0])
	{ if (l>=MAX_VERTICES) panic("Too many vertices");
	  switch (state)
	  { case 0:
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 1:
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 2:
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");
	    case 3:
	    if (hack_track_polygon_x[camera][frame][k][l-1]<
		width-hack_track_subsample[camera]&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      state = 0;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]<
		height-hack_track_subsample[camera]&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]+1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]+
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 3;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_x[camera][frame][k][l-1]>0&&
		map[hack_track_polygon_y[camera][frame][k][l-1]/
		    hack_track_subsample[camera]]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      state = 2;
	      l++;
	      goto l2;}
	    if (hack_track_polygon_y[camera][frame][k][l-1]>0&&
		map
		[hack_track_polygon_y[camera][frame][k][l-1]/
		 hack_track_subsample[camera]-1]
		[hack_track_polygon_x[camera][frame][k][l-1]/
		 hack_track_subsample[camera]])
	    { hack_track_polygon_y[camera][frame][k][l] =
		hack_track_polygon_y[camera][frame][k][l-1]-
		hack_track_subsample[camera];
	      hack_track_polygon_x[camera][frame][k][l] =
		hack_track_polygon_x[camera][frame][k][l-1];
	      state = 1;
	      l++;
	      goto l2;}
	    panic("This shouldn't happen");}}}
      hack_track_polygon_l[camera][frame][k] = l;
      if (colour[k]==0) hack_track_motion[camera][frame] = TRUE;}}}

int hack_track_interrupts(void) {return hack_track_interrupts_on;}

void hack_track_set_interrupts(int on) {hack_track_interrupts_on = on;}

void hack_track_handler(int signum)
{ unsigned char *p1, *p2, *pl;
  int k, l, camera = hack_track_camera;
  unsigned char buffer[hack_track_height[camera]*hack_track_width[camera]*4];
  if (!hack_track_interrupts_on) return;
  if (hack_track_using_v4l[camera])
  { v4l_mmap_sync(camera, 0);
    v4l_mmap_get_frame(camera);
    v4l_mmap_capture(camera, 0);}
  /* This is an extra copy. This copy is used three times. First to copy to
     hack_track_frames[camera]. Second to run the tracker. Third to display.
     This extra copy is made since the actual meteor buffer can change behind
     your back between different accesses. */
  memcpy(&buffer[0],
	 hack_track_buffer[camera],
	 hack_track_height[camera]*hack_track_width[camera]*4);
  /* hack_track_l[camera] is the capture downsample factor. If
     hack_track_l[camera]==0 then capturing is turned off. If
     hack_track_l[camera]!=0 then the capture rate is
     raw_frame_rate/hack_track_l[camera]. */
  if (hack_track_l[camera]>0)
  /* hack_track_k[camera] does the downsampling for capturing. It counts from
     0,...,hack_track_l[camera]-1 and cycles. Capturing is done when
     hack_track_k[camera]==0. */
  { hack_track_k[camera] = (hack_track_k[camera]+1)%hack_track_l[camera];
    if (hack_track_k[camera]==0)
    /* hack_track_i[camera] is the index of the current frame. It is used to
       index into the saved frames as well as the saved tracking data. */
    { if (hack_track_i[camera]<hack_track_n[camera])
      { hack_track_tracker(camera,
			   &buffer[0],
			    hack_track_i[camera],
			    hack_track_height[camera],
			    hack_track_width[camera],
			    hack_track_capturing[camera],
			    hack_track_capturing[camera],
			    hack_track_tracking_ellipses[camera],
			    hack_track_tracking_polygons[camera],
			    hack_track_hull[camera]);
	/* When viewing just the ellipses or polygons, and not the video
	   (since hack_track_m[camera]==0), draw the ellipses or polygons in
           black. */
	if ((hack_track_tracking_ellipses[camera]||
	     hack_track_tracking_polygons[camera])&&
	    hack_track_m[camera]==0)
	{ XClearArea(hack_track_display[camera],
		     hack_track_window[camera],
		     hack_track_window_x[camera],
		     hack_track_window_y[camera],
		     hack_track_width[camera],
		     hack_track_height[camera],
		     False);
	  XSetForeground(hack_track_display[camera],
			 hack_track_gc[camera],
			 XBlackPixel(hack_track_display[camera],
				     hack_track_screen[camera]));
	  /* Draw the ellipses. */
	  if (hack_track_tracking_ellipses[camera])
	  { for (k = 0; k<gobject_k[camera][hack_track_i[camera]]; k++)
	    { hack_track_draw_ellipse(camera,
				      gellipse_x
				      [camera][hack_track_i[camera]][k],
				      gellipse_y
				      [camera][hack_track_i[camera]][k],
				      gellipse_theta
				      [camera][hack_track_i[camera]][k],
				      gellipse_r
				      [camera][hack_track_i[camera]][k],
				      gellipse_s
				      [camera][hack_track_i[camera]][k]);}}
	  /* Draw the polygons. */
	  if (hack_track_tracking_polygons[camera])
	  { for (k = 0; k<gobject_k[camera][hack_track_i[camera]]; k++)
	    { for (l = 1;
		   l<hack_track_polygon_l[camera][hack_track_i[camera]][k];
		   l++)
	      { XDrawLine(hack_track_display[camera],
			  hack_track_window[camera],
			  hack_track_gc[camera],
			  hack_track_window_x[camera]+
			  hack_track_polygon_x
			  [camera][hack_track_i[camera]][k][l-1],
			  hack_track_window_y[camera]+
			  hack_track_polygon_y
			  [camera][hack_track_i[camera]][k][l-1],
			  hack_track_window_x[camera]+
			  hack_track_polygon_x
			  [camera][hack_track_i[camera]][k][l],
			  hack_track_window_y[camera]+
			  hack_track_polygon_y
			  [camera][hack_track_i[camera]][k][l]);}
	      XDrawLine(hack_track_display[camera],
			hack_track_window[camera],
			hack_track_gc[camera],
			hack_track_window_x[camera]+
			hack_track_polygon_x[camera]
			[hack_track_i[camera]]
			[k]
			[hack_track_polygon_l
			 [camera][hack_track_i[camera]][k]-1],
			hack_track_window_y[camera]+
			hack_track_polygon_y[camera]
			[hack_track_i[camera]]
			[k]
			[hack_track_polygon_l
			 [camera][hack_track_i[camera]][k]-1],
			hack_track_window_x[camera]+
			hack_track_polygon_x
			[camera][hack_track_i[camera]][k][0],
			hack_track_window_y[camera]+
			hack_track_polygon_y
			[camera][hack_track_i[camera]][k][0]);}}
	  XFlush(hack_track_display[camera]);}
	hack_track_i[camera]++;}
      /* Stop capturing when hack_track_i[camera]>=hack_track_n[camera]. */
      else hack_track_l[camera] = 0;}}
  /* hack_track_m[camera] is the viewfinder refresh downsample factor. If
     hack_track_m[camera]==0 then the viewfinder is turned off. If
     hack_track_m[camera]!=0
     then the viewfinder refresh rate is raw_frame_rate/hack_track_m[camera].
     */
  if (hack_track_m[camera]>0)
  /* hack_track_j[camera] does the downsampling for the viewfinder refresh. It
     counts from 0,...,hack_track_m[camera]-1 and cycles. Viewfinder refresh is
     done when hack_track_j[camera]==0. */
  { hack_track_j[camera] = (hack_track_j[camera]+1)%hack_track_m[camera];
    if (hack_track_j[camera]==0)
    /* Display the current video frame. The meteor buffer has four bytes per
       pixel. Depending on the X server, shmimage might have either three or
       four bytes per pixel. If it has four bytes per pixel then use memcpy
       since it is faster. If it has three bytes per pixel then we need to
       roll our own to do packing. */
    { if (hack_track_shmimage[camera]->bits_per_pixel==24)
      { for (p1 = &buffer[0],
	     p2 = &hack_track_shmimage[camera]->data[0],
	     pl = &buffer
	           [hack_track_height[camera]*hack_track_width[camera]*4];
	     p1<pl;)
	{ *p2++ = *p1++;
	  *p2++ = *p1++;
	  *p2++ = *p1++;
	  p1++;}}
      else memcpy(&hack_track_shmimage[camera]->data[0],
		  &buffer[0],
		  hack_track_height[camera]*hack_track_width[camera]*4);
      XShmPutImage(hack_track_display[camera],
		   hack_track_window[camera],
		   hack_track_gc[camera],
		   hack_track_shmimage[camera],
		   0,
		   0,
		   hack_track_window_x[camera],
		   hack_track_window_y[camera],
		   MIN(hack_track_width[camera],
		       hack_track_window_width[camera]),
		   MIN(hack_track_height[camera],
		       hack_track_window_height[camera]),
		   False);
      /* When viewing the ellipses or polygons overlayed on the video (since
	 hack_track_m[camera]>0), draw the ellipses or polygons in white. */
      if (hack_track_tracking_ellipses[camera]||
	  hack_track_tracking_polygons[camera])
      { XSetForeground(hack_track_display[camera], hack_track_gc[camera],
		       XWhitePixel(hack_track_display[camera],
				   hack_track_screen[camera]));
	/* Draw the ellipses. */
	if (hack_track_tracking_ellipses[camera])
	{ for (k = 0; k<gobject_k[camera][hack_track_i[camera]-1]; k++)
	  { hack_track_draw_ellipse(camera,
				    gellipse_x
				    [camera][hack_track_i[camera]-1][k],
				    gellipse_y
				    [camera][hack_track_i[camera]-1][k],
				    gellipse_theta
				    [camera][hack_track_i[camera]-1][k],
				    gellipse_r
				    [camera][hack_track_i[camera]-1][k],
				    gellipse_s
				    [camera][hack_track_i[camera]-1][k]);}}
	/* Draw the polygons. */
	if (hack_track_tracking_polygons[camera])
	{ for (k = 0; k<gobject_k[camera][hack_track_i[camera]-1]; k++)
	  { for (l = 1;
		 l<hack_track_polygon_l[camera][hack_track_i[camera]-1][k];
		 l++)
	    { XDrawLine(hack_track_display[camera],
			hack_track_window[camera],
			hack_track_gc[camera],
			hack_track_window_x[camera]+
			hack_track_polygon_x
			[camera][hack_track_i[camera]-1][k][l-1],
			hack_track_window_y[camera]+
			hack_track_polygon_y
			[camera][hack_track_i[camera]-1][k][l-1],
			hack_track_window_x[camera]+
			hack_track_polygon_x
			[camera][hack_track_i[camera]-1][k][l],
			hack_track_window_y[camera]+
			hack_track_polygon_y
			[camera][hack_track_i[camera]-1][k][l]);}
	    XDrawLine(hack_track_display[camera],
		      hack_track_window[camera],
		      hack_track_gc[camera],
		      hack_track_window_x[camera]+hack_track_polygon_x[camera]
		      [hack_track_i[camera]-1]
		      [k]
		      [hack_track_polygon_l
		       [camera][hack_track_i[camera]-1][k]-1],
		      hack_track_window_y[camera]+hack_track_polygon_y[camera]
		      [hack_track_i[camera]-1]
		      [k]
		      [hack_track_polygon_l
		       [camera][hack_track_i[camera]-1][k]-1],
		      hack_track_window_x[camera]+
		      hack_track_polygon_x
		      [camera][hack_track_i[camera]-1][k][0],
		      hack_track_window_y[camera]+
		      hack_track_polygon_y
		      [camera][hack_track_i[camera]-1][k][0]);}}}
      XFlush(hack_track_display[camera]);}}}

void hack_track_offline_tracker(int camera,
				int frame,
				int height,
				int width,
				int subsample,
				int capturing_code,
				int tracking_ellipses,
				int tracking_polygons,
				int hull)
{ unsigned char *p1, *p2, *pl;
  int y;
  unsigned char buffer[height*width*4];
  hack_track_subsample[camera] = subsample;
  /* The meteor buffer has four bytes per pixel and hack_track_frames[camera]
     has three bytes per pixel (to save space) so packing is done. Two loops
     are needed to allow subsampling the scan lines. */
  for (y = 0; y<height/hack_track_subsample[camera]; y++)
  { for (p1 = &buffer[hack_track_subsample[camera]*y*width*4],
	 p2 = &hack_track_frames[camera]
	       [(frame*height/hack_track_subsample[camera]+y)*width*3],
	 pl = &buffer[(hack_track_subsample[camera]*y+1)*width*4];
	 p1<pl;)
    { *p1++ = *p2++;
      *p1++ = *p2++;
      *p1++ = *p2++;
      p1++;}}
  hack_track_tracker(camera,
		     &buffer[0],
		      frame,
		      height,
		      width,
		      FALSE,
		      capturing_code,
		      tracking_ellipses,
		      tracking_polygons,
		      hull);}

void hack_track_draw_ellipse(int camera,
			     float x0,
			     float y0,
			     float t0,
			     float a,
			     float b)
{ float rxx = cos(t0);
  float rxy = -sin(t0);
  float ryx = -rxy;
  float ryy = rxx;
  float ex, ey, tx, ty, px, py;
  int i;
  for (i = 0; i<37; i++)
  { ex = a*sin(DEG_TO_RAD(10*i));
    ey = b*cos(DEG_TO_RAD(10*i));
    tx = rxx*ex+rxy*ey+x0;
    ty = ryx*ex+ryy*ey+y0;
    if (i!=0)
    { XDrawLine(hack_track_display[camera],
		hack_track_window[camera],
		hack_track_gc[camera],
		hack_track_window_x[camera]+tx,
		hack_track_window_y[camera]+ty,
		hack_track_window_x[camera]+px,
		hack_track_window_y[camera]+py);}
    px = tx;
    py = ty;}}

void hack_track_set_real_time(void)
{ struct sched_param sched_param;
  return;			/* debugging */
  if (hack_track_real_time==FALSE)
  { if (hack_track_uid==-1) hack_track_uid = getuid();
    if (setuid(0)==-1)
    { perror("hack_track setuid failed");
      exit(-1);}
    sched_param.sched_priority = 1;
    if (sched_setscheduler(0, SCHED_FIFO, &sched_param)==-1)
    { perror("hack_track sched_setscheduler SCHED_FIFO failed");
      exit(-1);}
    if (mlockall(MCL_FUTURE)==-1)
    { perror("hack_track mlockall failed");
      exit(-1);}
    if (setreuid(0, hack_track_uid)==-1)
    { perror("hack_track setreuid failed");
      exit(-1);}
    hack_track_real_time = TRUE;}}

void hack_track_set_nonreal_time(void)
{ struct sched_param sched_param;
  if (hack_track_real_time==TRUE)
  { if (hack_track_uid==-1) hack_track_uid = getuid();
    if (setuid(0)==-1)
    { perror("hack_track setuid failed");
      exit(-1);}
    sched_param.sched_priority = 0;
    if (sched_setscheduler(0, SCHED_OTHER, &sched_param)==-1)
    { perror("hack_track sched_setscheduler SCHED_OTHER failed");
      exit(-1);}
    if (munlockall()==-1)
    { perror("hack_track munlockall failed");
      exit(-1);}
    if (setreuid(0, hack_track_uid)==-1)
    { perror("hack_track setreuid failed");
      exit(-1);}
    hack_track_real_time = FALSE;}}

int hack_track_get_red(int camera, int i, int y, int x)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  return hack_track_frames[camera][p+2];}

int hack_track_get_green(int camera, int i, int y, int x)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  return hack_track_frames[camera][p+1];}

int hack_track_get_blue(int camera, int i, int y, int x)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  return hack_track_frames[camera][p];}

int hack_track_get_pixel(int camera, int i, int y, int x)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  return 65536*hack_track_frames[camera][p+2]+
           256*hack_track_frames[camera][p+1]+
	       hack_track_frames[camera][p];}

void hack_track_set_red(int camera, int i, int y, int x, int v)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  hack_track_frames[camera][p+2] = v;}

void hack_track_set_green(int camera, int i, int y, int x, int v)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  hack_track_frames[camera][p+1] = v;}

void hack_track_set_blue(int camera, int i, int y, int x, int v)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  hack_track_frames[camera][p] = v;}

void hack_track_set_pixel(int camera, int i, int y, int x, int v)
{ int p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
  hack_track_frames[camera][p+2] = v>>16;
  hack_track_frames[camera][p+1] = (v>>8)&255;
  hack_track_frames[camera][p] = v&255;}

int hack_track_get_code_frame_red(int camera, int i, int y, int x)
{ int c =  hack_track_code_frames[camera]
           [(i*(hack_track_height[camera]/hack_track_subsample[camera])+
	     y/hack_track_subsample[camera])*
	    (hack_track_width[camera]/hack_track_subsample[camera])+
	    x/hack_track_subsample[camera]];
  return (c==0?0:c==1?255:c==2?0:c==3?0:c==4?255:255);}

int hack_track_get_code_frame_green(int camera, int i, int y, int x)
{ int c =  hack_track_code_frames[camera]
           [(i*(hack_track_height[camera]/hack_track_subsample[camera])+
	     y/hack_track_subsample[camera])*
	    (hack_track_width[camera]/hack_track_subsample[camera])+
	    x/hack_track_subsample[camera]];
  return (c==0?0:c==1?0:c==2?255:c==3?0:c==4?255:255);}

int hack_track_get_code_frame_blue(int camera, int i, int y, int x)
{ int c =  hack_track_code_frames[camera]
           [(i*(hack_track_height[camera]/hack_track_subsample[camera])+
	     y/hack_track_subsample[camera])*
	    (hack_track_width[camera]/hack_track_subsample[camera])+
	    x/hack_track_subsample[camera]];
  return (c==0?0:c==1?0:c==2?0:c==3?255:c==4?0:255);}

void hack_track_copy_frame_to_ximage(int camera, int i, XImage *ximage)
{ int y, x, p;
  for (y = 0; y<hack_track_height[camera]; y++)
  { for (x = 0; x<hack_track_width[camera]; x++)
    { p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
      XPutPixel(ximage, x, y,
		65536*hack_track_frames[camera][p+2]+
		256*hack_track_frames[camera][p+1]+
		hack_track_frames[camera][p]);}}}

void hack_track_motion_detector(int camera, int i, XImage *ximage)
{ int y, x, p, q, r, g, b, t = 48*48;
  for (y = 0; y<hack_track_height[camera]; y++)
  { for (x = 0; x<hack_track_width[camera]; x++)
    { p = 3*
          (((i*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
      q = 3*
          ((((i+1)*hack_track_height[camera]+y)/hack_track_subsample[camera])*
	   hack_track_width[camera]+x);
      r = hack_track_frames[camera][q+2]-hack_track_frames[camera][p+2];
      g = hack_track_frames[camera][q+1]-hack_track_frames[camera][p+1];
      b = hack_track_frames[camera][q]-hack_track_frames[camera][p];
      XPutPixel(ximage, x, y, r*r+g*g+b*b<t?65536*255+256*255+255:0);}}}

void hack_track_set_thresholds(int camera,
			       int motion_threshold,
			       int colour_pixel_mass_threshold,
			       int colour_proximity_threshold,
			       int motion_pixel_mass_threshold,
			       int motion_proximity_threshold)
{ if (colour_proximity_threshold%2!=0)
  { panic ("colour_proximity_threshold must be a multiple of two");}
  if (motion_proximity_threshold%2!=0)
  { panic ("motion_proximity_threshold must be a multiple of two");}
  hack_track_motion_threshold[camera] = motion_threshold;
  hack_track_colour_pixel_mass_threshold[camera] = colour_pixel_mass_threshold;
  hack_track_colour_proximity_threshold[camera] = colour_proximity_threshold;
  hack_track_motion_pixel_mass_threshold[camera] = motion_pixel_mass_threshold;
  hack_track_motion_proximity_threshold[camera] = motion_proximity_threshold;}

void hack_track_set_red_range(int camera,
			      int hl,
			      int hh,
			      int sl,
			      int sh,
			      int vl,
			      int vh)
{ hack_track_rhl[camera] = hl;
  hack_track_rhh[camera] = hh;
  hack_track_rsl[camera] = sl;
  hack_track_rsh[camera] = sh;
  hack_track_rvl[camera] = vl;
  hack_track_rvh[camera] = vh;}

void hack_track_set_green_range(int camera,
				int hl,
				int hh,
				int sl,
				int sh,
				int vl,
				int vh)
{ hack_track_ghl[camera] = hl;
  hack_track_ghh[camera] = hh;
  hack_track_gsl[camera] = sl;
  hack_track_gsh[camera] = sh;
  hack_track_gvl[camera] = vl;
  hack_track_gvh[camera] = vh;}

void hack_track_set_blue_range(int camera,
			       int hl,
			       int hh,
			       int sl,
			       int sh,
			       int vl,
			       int vh)
{ hack_track_bhl[camera] = hl;
  hack_track_bhh[camera] = hh;
  hack_track_bsl[camera] = sl;
  hack_track_bsh[camera] = sh;
  hack_track_bvl[camera] = vl;
  hack_track_bvh[camera] = vh;}

void hack_track_set_yellow_range(int camera,
				 int hl,
				 int hh,
				 int sl,
				 int sh,
				 int vl,
				 int vh)
{ hack_track_yhl[camera] = hl;
  hack_track_yhh[camera] = hh;
  hack_track_ysl[camera] = sl;
  hack_track_ysh[camera] = sh;
  hack_track_yvl[camera] = vl;
  hack_track_yvh[camera] = vh;}

void hack_track_start(int camera, int frame)
{ gfirst_frame[camera] = frame;
  hack_track_first_frame[camera] = frame;
  hack_track_last_moving_valid[camera] = FALSE;
  hack_track_last_moving[camera] =
  make_c_int_matrix(hack_track_height[camera], hack_track_width[camera]);}

void hack_track_step(int camera, int frame, int object_frame)
{ int i, j, k, x, y, x1, y1, x2, y2, xl, yl, xh, yh, xp, yp, height, width;
  int count, n = 4, no_moving_clusters, once;
  int *colour_pythag, *motion_pythag;
  float mu_x, mu_y, sigma_xx, sigma_xy, sigma_yy;
  int **colour, **moving, **coloured_cluster, **moving_cluster;
  int **back_x, **back_y;
  float r, g, b, h, s, v, m, rc, gc, bc, rd, gd, bd;
  float t = hack_track_motion_threshold[camera]*
            hack_track_motion_threshold[camera];
  int p, q;
  height = hack_track_height[camera];
  width = hack_track_width[camera];
  /* Allocate storage */
  colour_pythag = make_c_int_vector(hack_track_colour_proximity_threshold[camera]+1);
  motion_pythag = make_c_int_vector(hack_track_motion_proximity_threshold[camera]+1);
  colour = make_c_int_matrix(height, width);
  moving = make_c_int_matrix(height, width);
  coloured_cluster = make_c_int_matrix(height, width);
  moving_cluster = make_c_int_matrix(height, width);
  back_x = make_c_int_matrix(height, width);
  back_y = make_c_int_matrix(height, width);
  /* Set up proximity clusterer */
  for (i = 0; i<=hack_track_colour_proximity_threshold[camera]; i++)
  { colour_pythag[i] =
    rint(sqrt(SQR(hack_track_colour_proximity_threshold[camera])-i*i));}
  for (i = 0; i<=hack_track_motion_proximity_threshold[camera]; i++)
  { motion_pythag[i] =
    rint(sqrt(SQR(hack_track_motion_proximity_threshold[camera])-i*i));}
  /* Process frame */
  for (y = 0; y<height; y++)
  { for (x = 0; x<width; x++)
    { p = 3*((((frame-1)*height+y)/hack_track_subsample[camera])*width+x);
      q = 3*(((frame*height+y)/hack_track_subsample[camera])*width+x);
      r = hack_track_frames[camera][q+2];
      g = hack_track_frames[camera][q+1];
      b = hack_track_frames[camera][q];
      if (frame!=hack_track_first_frame[camera])
      { rd = r-hack_track_frames[camera][p+2];
	gd = g-hack_track_frames[camera][p+1];
	bd = b-hack_track_frames[camera][p];}
      r = r/255.0;
      g = g/255.0;
      b = b/255.0;
      v = MAX(r, MAX(g, b));
      m = MIN(r, MIN(g, b));
      s = v==0.0?0.0:(v-m)/v;
      if (s==0.0) h = 0.0;
      else
      { rc = (v-r)/(v-m);
	gc = (v-g)/(v-m);
	bc = (v-b)/(v-m);
	h = (r==v?bc-gc:g==v?2.0+rc-bc:4.0+gc-rc)/6.0;
	if (h<0.0) h += 1.0;}
      h *= 360.0;
      s *= 100.0;
      v *= 100.0;
      if (hack_track_angle_between(hack_track_rhl[camera], h, hack_track_rhh[camera])&&
	  s>=hack_track_rsl[camera]&&s<=hack_track_rsh[camera]&&
	  v>=hack_track_rvl[camera]&&v<=hack_track_rvh[camera])
      { colour[y][x] = 0;
        moving[y][x] = FALSE;}
      else if (hack_track_angle_between(hack_track_ghl[camera], h, hack_track_ghh[camera])&&
	       s>=hack_track_gsl[camera]&&s<=hack_track_gsh[camera]&&
	       v>=hack_track_gvl[camera]&&v<=hack_track_gvh[camera])
      { colour[y][x] = 1;
        moving[y][x] = FALSE;}
      else if (hack_track_angle_between(hack_track_bhl[camera], h, hack_track_bhh[camera])&&
	       s>=hack_track_bsl[camera]&&s<=hack_track_bsh[camera]&&
	       v>=hack_track_bvl[camera]&&v<=hack_track_bvh[camera])
      { colour[y][x] = 2;
        moving[y][x] = FALSE;}
      else if (hack_track_angle_between(hack_track_yhl[camera], h, hack_track_yhh[camera])&&
	       s>=hack_track_ysl[camera]&&s<=hack_track_ysh[camera]&&
	       v>=hack_track_yvl[camera]&&v<=hack_track_yvh[camera])
      { colour[y][x] = 3;
        moving[y][x] = FALSE;}
      else if (frame!=hack_track_first_frame[camera]&&rd*rd+gd*gd+bd*bd>=t)
      { colour[y][x] = -1;
        moving[y][x] = TRUE;}
      else
      { colour[y][x] = -1;
        moving[y][x] = FALSE;}}}
  /* Cluster coloured objects by proximity, ignoring small clusters */
  k = 0;
  for (y = 0; y<height; y++)
  { for (x = 0; x<width; x++) coloured_cluster[y][x] = -1;}
  for (i = 0; i<n; i++)
  { for (y = 0; y<height; y++)
    { for (x = 0; x<width; x++)
      { if (colour[y][x]==i&&coloured_cluster[y][x]==-1)
	{ coloured_cluster[y][x] = k;
	  count = 1;
	  back_y[y][x] = -1;
	  back_x[y][x] = -1;
	  yp = y;
	  xp = x;
	  yl = y;
	  xl = x;
	  yh = y;
	  xh = x;
	  while (yp!=-1)
	  { y1 = yp;
	    x1 = xp;
	    yp = back_y[y1][x1];
	    xp = back_x[y1][x1];
	    if (coloured_cluster[y1][x1]==k)
	    { for (y2 = MAX(0, y1-hack_track_colour_proximity_threshold[camera]);
		   y2<MIN(height, y1+hack_track_colour_proximity_threshold[camera]+1);
		   y2++)
	      { q = colour_pythag[abs(y2-y1)];
		for (x2 = MAX(0, x1-q); x2<MIN(width, x1+q+1); x2++)
		{ if (colour[y2][x2]==i&&coloured_cluster[y2][x2]==-1)
		  { coloured_cluster[y2][x2] = k;
		    count++;
		    back_y[y2][x2] = yp;
		    back_x[y2][x2] = xp;
		    yp = y2;
		    xp = x2;
		    yl = MIN(yl, y2);
		    xl = MIN(xl, x2);
		    yh = MAX(yh, y2);
		    xh = MAX(xh, x2);}}}}}
	  if (count>=hack_track_colour_pixel_mass_threshold[camera]) k++;
	  else
	  { for (y1 = yl; y1<=yh; y1++)
	    { for (x1 = xl; x1<=xh; x1++)
	      if (coloured_cluster[y1][x1]==k)
	      { coloured_cluster[y1][x1] = -2;
		colour[y1][x1] = -1;}}}}}}}
  /* Cluster moving objects by proximity, ignoring small clusters */
  once = FALSE;
  again:
  no_moving_clusters = TRUE;
  for (y = 0; y<height; y++)
  { for (x = 0; x<width; x++) moving_cluster[y][x] = -1;}
  for (y = 0; y<height; y++)
  { for (x = 0; x<width; x++)
    { if (moving[y][x]&&moving_cluster[y][x]==-1)
      { moving_cluster[y][x] = k;
	back_y[y][x] = -1;
	back_x[y][x] = -1;
	yp = y;
	xp = x;
	yl = y;
	xl = x;
	yh = y;
	xh = x;
	count = 1;
	while (yp!=-1)
	{ y1 = yp;
	  x1 = xp;
	  yp = back_y[y1][x1];
	  xp = back_x[y1][x1];
	  if (moving_cluster[y1][x1]==k)
	  { for (y2 = MAX(0, y1-hack_track_motion_proximity_threshold[camera]);
		 y2<MIN(height, y1+hack_track_motion_proximity_threshold[camera]+1);
		 y2++)
	    { q = motion_pythag[abs(y2-y1)];
	      for (x2 = MAX(0, x1-q); x2<MIN(width, x1+q+1); x2++)
	      { if (moving[y2][x2]&&moving_cluster[y2][x2]==-1)
		{ moving_cluster[y2][x2] = k;
		  count++;
		  back_y[y2][x2] = yp;
		  back_x[y2][x2] = xp;
		  yp = y2;
		  xp = x2;
		  yl = MIN(yl, y2);
		  xl = MIN(xl, x2);
		  yh = MAX(yh, y2);
		  xh = MAX(xh, x2);}}}}}
        if (count>=hack_track_motion_pixel_mass_threshold[camera])
	{ k++;
	  no_moving_clusters = FALSE;}
	else
	{ for (y1 = yl; y1<=yh; y1++)
	  { for (x1 = xl; x1<=xh; x1++)
	    if (moving_cluster[y1][x1]==k)
	    { moving_cluster[y1][x1] = -2;
	      moving[y1][x1] = FALSE;}}}}}}
  if (no_moving_clusters)
  { if (hack_track_last_moving_valid[camera])
    { if (!once)
      { for (y = 0; y<height; y++)
        { for (x = 0; x<width; x++)
	  { moving[y][x] = hack_track_last_moving[camera][y][x];}}
	  once = TRUE;
	  goto again;}}}
  else if (!once)
  { for (y = 0; y<height; y++)
    { for (x = 0; x<width; x++)
      { hack_track_last_moving[camera][y][x] = moving[y][x];}}
    if (!hack_track_last_moving_valid[camera])
    { hack_track_last_moving_valid[camera] = TRUE;
      gfirst_frame[camera] = frame;}
    glast_frame[camera] = frame;}
  if (k>MAX_OBJECTS) panic("Too many objects");
  /* Fill object_frame */
  for (y = 0; y<height; y++)
  { for (x = 0; x<width; x++)
    { q = 3*(((object_frame*height+y)/hack_track_subsample[camera])*width+x);
      if (moving[y][x])
      { r = 0;
        g = 0;
        b = 0;}
      else switch (colour[y][x])
      { case 0: r = 255; g = 0; b = 0; break;
        case 1: r = 0; g = 255; b = 0; break;
	case 2: r = 0; g = 0; b = 255; break;
        case 3: r = 255; g = 255; b = 0; break;
        default: r = 255; g = 255; b = 255;}
      hack_track_frames[camera][q+2] = r;
      hack_track_frames[camera][q+1] = g;
      hack_track_frames[camera][q] = b;}}
  /* Fit ellipses to clusters */
  gobject_k[camera][frame] = k;
  for (i = 0; i<k; i++)
  { mu_x = 0.0;
    mu_y = 0.0;
    sigma_xx = 0.0;
    sigma_xy = 0.0;
    sigma_yy = 0.0;
    j = 0;
    for (y = 0; y<height; y++)
    { for (x = 0; x<width; x++)
      if (coloured_cluster[y][x]==i||moving_cluster[y][x]==i)
      { j++;
	mu_x += x;
	mu_y += y;}}
    mu_x /= j;
    mu_y /= j;
    for (y = 0; y<height; y++)
    { for (x = 0; x<width; x++)
      if (coloured_cluster[y][x]==i||moving_cluster[y][x]==i)
      { sigma_xx += (x-mu_x)*(x-mu_x);
	sigma_xy += (x-mu_x)*(y-mu_y);
	sigma_yy += (y-mu_y)*(y-mu_y);}}
    sigma_xx /= j;
    sigma_xy /= j;
    sigma_yy /= j;
    gellipse_x[camera][frame][i] = mu_x;
    gellipse_y[camera][frame][i] = mu_y;
    gellipse_theta[camera][frame][i] = eigenvector_angle1(sigma_xx,
						   sigma_xy,
						   sigma_xy,
						   sigma_yy);
    gellipse_r[camera][frame][i] = sqrt(2.0*eigenvalue1(sigma_xx,
						 sigma_xy,
						 sigma_xy,
						 sigma_yy));
    gellipse_s[camera][frame][i] = sqrt(2.0*eigenvalue2(sigma_xx,
						 sigma_xy,
						 sigma_xy,
						 sigma_yy));}
  /* Free storage */
  free_c_int_vector(colour_pythag);
  free_c_int_vector(motion_pythag);
  free_c_int_matrix(colour, height);
  free_c_int_matrix(moving, height);
  free_c_int_matrix(coloured_cluster, height);
  free_c_int_matrix(moving_cluster, height);
  free_c_int_matrix(back_x, height);
  free_c_int_matrix(back_y, height);}

void hack_track_finish(int camera)
{ free_c_int_matrix(hack_track_last_moving[camera],
		    hack_track_height[camera]);}

void hack_track_show_frame(int camera, int i)
{ int y;
  unsigned char *p, *q, *r;
  if (hack_track_shmimage[camera]->bits_per_pixel==24)
  { for (y = 0; y<hack_track_height[camera]; y++)
    { for (p = &hack_track_frames[camera]
                [((i*hack_track_height[camera]+y)/
		  hack_track_subsample[camera])*
		 hack_track_width[camera]*3],
           q = &hack_track_shmimage[camera]->
	        data[y*hack_track_width[camera]*3],
           r = &hack_track_frames[camera]
                [(((i*hack_track_height[camera]+y)/
		   hack_track_subsample[camera])+1)*
		 hack_track_width[camera]*3];
           p<r;)
      { *q++ = *p++;
        *q++ = *p++;
        *q++ = *p++;}}}
  else
  { for (y = 0; y<hack_track_height[camera]; y++)
    { for (p = &hack_track_frames[camera]
	        [((i*hack_track_height[camera]+y)/
		  hack_track_subsample[camera])*
		 hack_track_width[camera]*3],
	   q = &hack_track_shmimage[camera]->
	        data[y*hack_track_width[camera]*4],
	   r = &hack_track_frames[camera]
                [(((i*hack_track_height[camera]+y)/
		   hack_track_subsample[camera])+1)*
		 hack_track_width[camera]*3];
	   p<r;)
      { *q++ = *p++;
        *q++ = *p++;
        *q++ = *p++;
        q++;}}}
  XShmPutImage(hack_track_display[camera],
	       hack_track_window[camera],
	       hack_track_gc[camera],
	       hack_track_shmimage[camera],
	       0,
	       0,
	       hack_track_window_x[camera],
	       hack_track_window_y[camera],
	       MIN(hack_track_width[camera], hack_track_window_width[camera]),
	       MIN(hack_track_height[camera],
		   hack_track_window_height[camera]),
	       False);
  XFlush(hack_track_display[camera]);}

void hack_track_show_code_frame(int camera, int i)
{ int y, x;
  if (hack_track_shmimage[camera]->bits_per_pixel==24)
  { for (y = 0; y<hack_track_height[camera]; y++)
    { for (x = 0; x<hack_track_width[camera]; x++)
      { hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*3] =
	hack_track_get_code_frame_blue(camera, i, y, x);
	hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*3+1] =
	hack_track_get_code_frame_green(camera, i, y, x);
	hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*3+2] =
	hack_track_get_code_frame_red(camera, i, y, x);}}}
  else
  { for (y = 0; y<hack_track_height[camera]; y++)
    { for (x = 0; x<hack_track_width[camera]; x++)
      { hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*4] =
	hack_track_get_code_frame_blue(camera, i, y, x);
	hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*4+1] =
	hack_track_get_code_frame_green(camera, i, y, x);
	hack_track_shmimage[camera]->data[(y*hack_track_width[camera]+x)*4+2] =
	hack_track_get_code_frame_red(camera, i, y, x);}}}
  XShmPutImage(hack_track_display[camera],
	       hack_track_window[camera],
	       hack_track_gc[camera],
	       hack_track_shmimage[camera],
	       0,
	       0,
	       hack_track_window_x[camera],
	       hack_track_window_y[camera],
	       MIN(hack_track_width[camera], hack_track_window_width[camera]),
	       MIN(hack_track_height[camera],
		   hack_track_window_height[camera]),
	       False);
  XFlush(hack_track_display[camera]);}

void hack_track_free(int camera)
{ free(hack_track_frames[camera]);
  free(hack_track_code_frames[camera]);
  free(hack_track_last_frame[camera]);
  free(hack_track_last_code[camera]);
  free(hack_track_conjure_code[camera]);
  free(hack_track_last_edge[camera]);
  free(hack_track_viff[camera]->imagedata);
  free(hack_track_viff[camera]);}

void hack_track_attach_viewfinder(int camera,
				  Display *display,
				  int screen,
				  Window window,
				  int window_x,
				  int window_y,
				  int window_width,
				  int window_height)
{ XWindowAttributes attributes;
  Visual *visual;
  int visualid;
  int depth;
  XGCValues gc_values;
  hack_track_display[camera] = display;
  hack_track_screen[camera] = screen;
  hack_track_window[camera] = window;
  hack_track_window_x[camera] = window_x;
  hack_track_window_y[camera] = window_y;
  hack_track_window_width[camera] = window_width;
  hack_track_window_height[camera] = window_height;
  XGetWindowAttributes(display, window, &attributes);
  visual = attributes.visual;
  depth = attributes.depth;
  if (depth!=24&&depth!=32) panic("unrecognized depth");
  visualid = attributes.visual->visualid;
  if (visualid!=32&&visualid!=33&&visualid!=34&&visualid!=35)
  { panic("unrecognized visual id");}
  gc_values.graphics_exposures = False;
  /* needs work: To check that succeeds */
  hack_track_gc[camera] =
    XCreateGC(display, window, GCGraphicsExposures, &gc_values);
  /* needs work: To check that succeeds */
  hack_track_shmimage[camera] =
    XShmCreateImage(display,
		    visual,
		    depth,
		    ZPixmap,
		    NULL,
		    &hack_track_shminfo[camera],
		    MIN(hack_track_width[camera],
			hack_track_window_width[camera]),
		    MIN(hack_track_height[camera],
			hack_track_window_height[camera]));
  if (hack_track_shmimage[camera]->bits_per_pixel!=24&&
      hack_track_shmimage[camera]->bits_per_pixel!=32)
  { panic("unrecognized bits_per_pixel");}
  if (hack_track_shmimage[camera]->bytes_per_line>4*640||
      hack_track_shmimage[camera]->height>480)
  { fprintf(stderr, "you don't want to know\n");
    exit(-1);}
  if ((hack_track_shminfo[camera].shmid =
       shmget(IPC_PRIVATE, 4*640*480, IPC_CREAT|0777))==-1)
  { perror("hack_track shmget failed");
    exit(-1);}
  if ((hack_track_shminfo[camera].shmaddr =
       shmat(hack_track_shminfo[camera].shmid, (char *)0, 0))==
      (char *)(-1))
  { perror("hack_track shmat failed");
    exit(-1);}
  hack_track_shmimage[camera]->data = hack_track_shminfo[camera].shmaddr;
  /* needs work: To check that succeeds */
  XShmAttach(display, &hack_track_shminfo[camera]);}

void hack_track_detach_viewfinder(int camera)
/* needs work: To check that succeeds */
{ XShmDetach(hack_track_display[camera], &hack_track_shminfo[camera]);
  if (shmdt(hack_track_shminfo[camera].shmaddr)==-1)
  { perror("hack_track shmdt failed");
    exit(-1);}
  /* needs work: To undo shmget */
  /* needs work: To undo XShmCreateImage */
  /* needs work: To check that succeeds */
  XFreeGC(hack_track_display[camera], hack_track_gc[camera]);}

void hack_track_sigaction(int camera)
{ struct sigaction sigact;
  hack_track_camera = camera;
  sigact.sa_handler = hack_track_handler;
  sigemptyset(&sigact.sa_mask);
  sigact.sa_flags = SA_RESTART;
  if (sigaction(hack_track_using_v4l[camera]?SIGALRM:SIGUSR2, &sigact, NULL))
  { perror("hack_track sigaction failed");
    exit(-1);}}

void hack_track_block(void)
{ sigset_t set;
  sigemptyset(&set);
  /* needs work: hack_track_using_v4l[0] */
  sigaddset(&set, hack_track_using_v4l[0]?SIGALRM:SIGUSR2);
  sigprocmask(SIG_BLOCK, &set, NULL);}

void hack_track_unblock(void)
{ sigset_t set;
  sigemptyset(&set);
  /* needs work: hack_track_using_v4l[0] */
  sigaddset(&set, hack_track_using_v4l[0]?SIGALRM:SIGUSR2);
  sigprocmask(SIG_UNBLOCK, &set, NULL);}

void hack_track_turn_on_viewfinder(int camera, int m)
{ if (m<=0) panic("m must be positive");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_l[camera] = 0;
  hack_track_m[camera] = m;}

void hack_track_turn_on_capturing(int camera, int i, int l, int n)
{ if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;}

void hack_track_turn_on_ellipse_tracker(int camera, int i, int l, int n)
{ if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = TRUE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;}

void hack_track_turn_on_ellipse_tracker_with_capturing(int camera,
						       int i,
						       int l,
						       int n)
{ if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = TRUE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;}

void hack_track_turn_on_polygon_tracker(int camera, int i, int l, int n, int h)
{ if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_hull[camera] = h;
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = TRUE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;}

void hack_track_turn_on_polygon_tracker_with_capturing(int camera,
						       int i,
						       int l,
						       int n,
						       int h)
{ if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_hull[camera] = h;
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = TRUE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;}

void hack_track_turn_off(int camera)
{ hack_track_block();		/* needs work: may turn off other copy */
  hack_track_l[camera] = 0;
  hack_track_m[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_set_nonreal_time();}

void hack_track_capture_frames(int camera, int i, int l, int n)
{ int real_time = hack_track_real_time;
  if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;
  while (hack_track_i[camera]<hack_track_n[camera]) pause();
  if (real_time==FALSE) hack_track_set_nonreal_time();
  hack_track_block();
  hack_track_l[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;}

void hack_track_track_ellipses(int camera, int i, int l, int n)
{ int real_time = hack_track_real_time;
  if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = TRUE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;
  while (hack_track_i[camera]<hack_track_n[camera]) pause();
  if (real_time==FALSE) hack_track_set_nonreal_time();
  hack_track_block();
  hack_track_l[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;}

void hack_track_track_ellipses_and_capture_frames(int camera,
						  int i,
						  int l,
						  int n)
{ int real_time = hack_track_real_time;
  if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = TRUE;
  hack_track_tracking_polygons[camera] = FALSE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;
  while (hack_track_i[camera]<hack_track_n[camera]) pause();
  if (real_time==FALSE) hack_track_set_nonreal_time();
  hack_track_block();
  hack_track_l[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;}

void hack_track_track_polygons(int camera, int i, int l, int n, int h)
{ int real_time = hack_track_real_time;
  if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_hull[camera] = h;
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = TRUE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;
  while (hack_track_i[camera]<hack_track_n[camera]) pause();
  if (real_time==FALSE) hack_track_set_nonreal_time();
  hack_track_block();
  hack_track_l[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;}

void hack_track_track_polygons_and_capture_frames(int camera,
						  int i,
						  int l,
						  int n,
						  int h)
{ int real_time = hack_track_real_time;
  if (i<0||i>=MAX_FRAMES) panic("i out of bounds");
  if (l<=0) panic("l must be positive");
  if (n<=0||n>MAX_FRAMES) panic("n out of bounds");
  hack_track_hull[camera] = h;
  hack_track_set_real_time();
  hack_track_unblock();
  hack_track_capturing[camera] = TRUE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = TRUE;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;
  hack_track_i[camera] = i;
  hack_track_j[camera] = 0;
  hack_track_k[camera] = 0;
  hack_track_n[camera] = n;
  hack_track_l[camera] = l;
  while (hack_track_i[camera]<hack_track_n[camera]) pause();
  if (real_time==FALSE) hack_track_set_nonreal_time();
  hack_track_block();
  hack_track_l[camera] = 0;
  hack_track_capturing[camera] = FALSE;
  hack_track_tracking_ellipses[camera] = FALSE;
  hack_track_tracking_polygons[camera] = FALSE;}

void hack_track_malloc(int camera, int nframes)
{ int y;
  hack_track_frames[camera] =
  (unsigned char *)
  malloc(nframes*(hack_track_height[camera]/hack_track_subsample[camera])*
	 hack_track_width[camera]*3*sizeof(unsigned char));
  if (hack_track_frames[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  hack_track_code_frames[camera] =
  (unsigned char *)
  malloc(nframes*
	 (hack_track_height[camera]/hack_track_subsample[camera])*
	 (hack_track_width[camera]/hack_track_subsample[camera])*
	 sizeof(unsigned char));
  if (hack_track_code_frames[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  hack_track_last_frame[camera] =
  (unsigned char *)
  malloc((hack_track_height[camera]/hack_track_subsample[camera])*
	 hack_track_width[camera]*3*sizeof(unsigned char));
  if (hack_track_last_frame[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  /* This is non-ANSI */
  hack_track_last_code[camera] =
  (unsigned char **)
  malloc((hack_track_height[camera]/hack_track_subsample[camera])*
	 sizeof(unsigned char *)+
	 ((hack_track_height[camera]/hack_track_subsample[camera])*
	  (hack_track_width[camera]/hack_track_subsample[camera])*
	  sizeof(unsigned char)));
  if (hack_track_last_code[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  for (y = 0; y<hack_track_height[camera]/hack_track_subsample[camera]; y++)
  { hack_track_last_code[camera][y] =
    &((unsigned char *)
      &hack_track_last_code[camera][hack_track_height[camera]/
				    hack_track_subsample[camera]])
    [y*hack_track_width[camera]/hack_track_subsample[camera]];}
  /* This is non-ANSI */
  hack_track_conjure_code[camera] =
  (unsigned char **)
  malloc((hack_track_height[camera]/hack_track_subsample[camera])*
	 sizeof(unsigned char *)+
	 ((hack_track_height[camera]/hack_track_subsample[camera])*
	  (hack_track_width[camera]/hack_track_subsample[camera])*
	  sizeof(unsigned char)));
  if (hack_track_conjure_code[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  for (y = 0; y<hack_track_height[camera]/hack_track_subsample[camera]; y++)
  { hack_track_conjure_code[camera][y] =
    &((unsigned char *)
      &hack_track_conjure_code[camera][hack_track_height[camera]/
				       hack_track_subsample[camera]])
    [y*hack_track_width[camera]/hack_track_subsample[camera]];}
  /* This is non-ANSI */
  hack_track_last_edge[camera] =
  (unsigned char **)
  malloc((hack_track_height[camera]/hack_track_subsample[camera])*
	 sizeof(unsigned char *)+
	 ((hack_track_height[camera]/hack_track_subsample[camera])*
	  (hack_track_width[camera]/hack_track_subsample[camera])*
	  sizeof(unsigned char)));
  if (hack_track_last_edge[camera]==NULL)
  { fprintf(stderr, "hack_track malloc failed\n");
    exit(-1);}
  for (y = 0; y<hack_track_height[camera]/hack_track_subsample[camera]; y++)
  { hack_track_last_edge[camera][y] =
    &((unsigned char *)
      &hack_track_last_edge[camera][hack_track_height[camera]/
				    hack_track_subsample[camera]])
    [y*hack_track_width[camera]/hack_track_subsample[camera]];}
  hack_track_viff[camera] =
    createimage(hack_track_height[camera]/hack_track_subsample[camera],
                hack_track_width[camera]/hack_track_subsample[camera],
                VFF_TYP_1_BYTE, 1, 1, "edges", 0, 0,
                VFF_MS_NONE, VFF_MAPTYP_NONE, VFF_LOC_IMPLICIT, 0);}

void hack_track_startup(int camera,
			int height,
			int width,
			int nframes,
			int subsample,
			int raw_frame_rate)
{ hack_track_using_v4l[camera] = v4l_available(camera);
  v4l_open_video(camera);
  hack_track_sigaction(camera);
  v4l_set_agc(camera, -1);
  v4l_set_shutter(camera, -1);
  v4l_set_compression(camera, 3);
  v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
  v4l_set_brightness(camera, 32768);
  v4l_set_contrast(camera, 32768);
  v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
  v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
  v4l_set_whiteness(camera, 32768);
  v4l_set_size(camera, width, height);
  v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
  if (v4l_get_frame_rate(camera)!=raw_frame_rate)
  { fprintf(stderr, "hack_track unsupported frame rate\n");
    exit(-1);}
  hack_track_height[camera] = height;
  hack_track_width[camera] = width;
  hack_track_subsample[camera] = subsample;
  hack_track_malloc(camera, nframes);
  v4l_mmap_frame(camera);
  hack_track_buffer[camera] = v4l_converted_frame[camera];
  hack_track_display[camera] = NULL;
  v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_startup_offline(int camera,
				int height,
				int width,
				int nframes,
				int subsample)
{ hack_track_height[camera] = height;
  hack_track_width[camera] = width;
  hack_track_subsample[camera] = subsample;
  hack_track_malloc(camera, nframes);
  hack_track_display[camera] = NULL;
  hack_track_starting[camera] = TRUE;
  hack_track_conjuring[camera] = 0;}

void hack_track_startup_with_viewfinder(int camera,
					int height,
					int width,
					int nframes,
					int subsample,
					Display *display,
					int screen,
					Window window,
					int window_x,
					int window_y,
					int window_width,
					int window_height,
					int raw_frame_rate)
{ hack_track_using_v4l[camera] = v4l_available(camera);
  v4l_open_video(camera);
  hack_track_sigaction(camera);
  v4l_set_agc(camera, -1);
  v4l_set_shutter(camera, -1);
  v4l_set_compression(camera, 3);
  v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
  v4l_set_brightness(camera, 32768);
  v4l_set_contrast(camera, 32768);
  v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
  v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
  v4l_set_whiteness(camera, 32768);
  v4l_set_size(camera, width, height);
  v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
  if (v4l_get_frame_rate(camera)!=raw_frame_rate)
  { fprintf(stderr, "hack_track unsupported frame rate\n");
    exit(-1);}
  hack_track_height[camera] = height;
  hack_track_width[camera] = width;
  hack_track_subsample[camera] = subsample;
  hack_track_malloc(camera, nframes);
  v4l_mmap_frame(camera);
  hack_track_buffer[camera] = v4l_converted_frame[camera];
  hack_track_attach_viewfinder(camera,
			       display,
			       screen,
			       window,
			       window_x,
			       window_y,
			       window_width,
			       window_height);
  v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_restartup(int camera,
			  int height,
			  int width,
			  int nframes,
			  int subsample,
			  int raw_frame_rate)
{ hack_track_l[camera] = 0;
  hack_track_m[camera] = 0;
  v4l_interrupt_off();
  if (hack_track_display[camera]!=NULL) hack_track_detach_viewfinder(camera);
  v4l_munmap_frame(camera);
  hack_track_free(camera);
  v4l_close_video(camera);
  if (hack_track_display[camera]!=NULL)
  XClearArea(hack_track_display[camera],
	     hack_track_window[camera],
	     hack_track_window_x[camera],
	     hack_track_window_y[camera],
	     hack_track_width[camera],
	     hack_track_height[camera],
	     False);
  v4l_open_video(camera);
  v4l_set_agc(camera, -1);
  v4l_set_shutter(camera, -1);
  v4l_set_compression(camera, 3);
  v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
  v4l_set_brightness(camera, 32768);
  v4l_set_contrast(camera, 32768);
  v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
  v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
  v4l_set_whiteness(camera, 32768);
  v4l_set_size(camera, width, height);
  v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
  if (v4l_get_frame_rate(camera)!=raw_frame_rate)
  { fprintf(stderr, "hack_track unsupported frame rate\n");
    exit(-1);}
  hack_track_height[camera] = height;
  hack_track_width[camera] = width;
  hack_track_subsample[camera] = subsample;
  hack_track_malloc(camera, nframes);
  v4l_mmap_frame(camera);
  hack_track_buffer[camera] = v4l_converted_frame[camera];
  if (hack_track_display[camera]!=NULL)
  { hack_track_attach_viewfinder(camera,
				 hack_track_display[camera],
				 hack_track_screen[camera],
				 hack_track_window[camera],
				 hack_track_window_x[camera],
				 hack_track_window_y[camera],
				 hack_track_window_width[camera],
				 hack_track_window_height[camera]);}
  v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_page_in_frames(int camera, int iframes, int nframes)
{ int i = iframes*(hack_track_height[camera]/hack_track_subsample[camera])*
          hack_track_width[camera]*3*sizeof(unsigned char);
  int n = nframes*(hack_track_height[camera]/hack_track_subsample[camera])*
          hack_track_width[camera]*3*sizeof(unsigned char);
  for (; i<n; i++) hack_track_frames[camera][i]++;}

void hack_track_shutdown(int camera)
{ hack_track_l[camera] = 0;
  hack_track_m[camera] = 0;
  v4l_interrupt_off();
  if (hack_track_display[camera]!=NULL) hack_track_detach_viewfinder(camera);
  v4l_munmap_frame(camera);
  hack_track_free(camera);
  v4l_close_video(camera);
  hack_track_set_nonreal_time();}

void hack_track_shutdown_offline(int camera) {hack_track_free(camera);}

void hack_track_send_frame(int camera, FILE *f, int i)
{ int amount = 3*(hack_track_height[camera]/hack_track_subsample[camera])*
    hack_track_width[camera];
  int p = 3*(((i+1)*hack_track_height[camera])/hack_track_subsample[camera])*
          hack_track_width[camera];
  while (amount>0)
  { amount -= write(fileno(f), &hack_track_frames[camera][p-amount], amount);}}

void hack_track_receive_frame(int camera, FILE *f, int i)
{ int amount = 3*(hack_track_height[camera]/hack_track_subsample[camera])*
    hack_track_width[camera];
  char *p = &hack_track_frames[camera]
             [3*((i*hack_track_height[camera])/hack_track_subsample[camera])*
	      hack_track_width[camera]];
  for (; amount>0; amount--) *(p++) = fgetc(f);}

void hack_track_handler_multiple(int signum)
{ unsigned char *p1, *p2, *pl;
  int k, l, camera;
  /* needs work: This only works if camera 0 has the largest height and
                 width */
  unsigned char buffer[hack_track_height[0]*hack_track_width[0]*4];
  if (!hack_track_interrupts_on) return;
  for (camera = 0; camera<hack_track_ncameras; camera++)
  {
  if (hack_track_using_v4l[camera])
  { v4l_mmap_sync(camera, 0);
    v4l_mmap_get_frame(camera);
    v4l_mmap_capture(camera, 0);}
  /* This is an extra copy. This copy is used three times. First to copy to
     hack_track_frames[camera]. Second to run the tracker. Third to display. This
     extra copy is made since the actual meteor buffer can change behind your
     back between different accesses. */
  memcpy(&buffer[0],
	 hack_track_buffer[camera],
	 hack_track_height[camera]*hack_track_width[camera]*4);
  /* hack_track_l[camera] is the capture downsample factor. If hack_track_l[camera]==0 then
     capturing is turned off. If hack_track_l[camera]!=0 then the capture rate is
     raw_frame_rate/hack_track_l[camera]. */
  if (hack_track_l[camera]>0)
  /* hack_track_k[camera] does the downsampling for capturing. It counts from
     0,...,hack_track_l[camera]-1 and cycles. Capturing is done when hack_track_k[camera]==0.
     */
  { hack_track_k[camera] = (hack_track_k[camera]+1)%hack_track_l[camera];
    if (hack_track_k[camera]==0)
    /* hack_track_i[camera] is the index of the current frame. It is used to index
       into the saved frames as well as the saved tracking data. */
    { if (hack_track_i[camera]<hack_track_n[camera])
      { hack_track_tracker(camera,
			   &buffer[0],
			   hack_track_i[camera],
			   hack_track_height[camera],
			   hack_track_width[camera],
			   hack_track_capturing[camera],
			   hack_track_capturing[camera],
			   hack_track_tracking_ellipses[camera],
			   hack_track_tracking_polygons[camera],
			   hack_track_hull[camera]);
	/* When viewing just the ellipses or polygons, and not the video
	   (since hack_track_m[camera]==0), draw the ellipses or polygons in black. */
	if ((hack_track_tracking_ellipses[camera]||hack_track_tracking_polygons[camera])&&
	    hack_track_m[camera]==0)
	{ XClearArea(hack_track_display[camera],
		     hack_track_window[camera],
		     hack_track_window_x[camera],
		     hack_track_window_y[camera],
		     hack_track_width[camera],
		     hack_track_height[camera],
		     False);
	  XSetForeground(hack_track_display[camera],
			 hack_track_gc[camera],
			 XBlackPixel(hack_track_display[camera], hack_track_screen[camera]));
	  /* Draw the ellipses. */
	  if (hack_track_tracking_ellipses[camera])
	  { for (k = 0; k<gobject_k[camera][hack_track_i[camera]]; k++)
	    { hack_track_draw_ellipse(camera,
				      gellipse_x[camera][hack_track_i[camera]][k],
				      gellipse_y[camera][hack_track_i[camera]][k],
				      gellipse_theta[camera][hack_track_i[camera]][k],
				      gellipse_r[camera][hack_track_i[camera]][k],
				      gellipse_s[camera][hack_track_i[camera]][k]);}}
	  /* Draw the polygons. */
	  if (hack_track_tracking_polygons[camera])
	  { for (k = 0; k<gobject_k[camera][hack_track_i[camera]]; k++)
	    { for (l = 1; l<hack_track_polygon_l[camera][hack_track_i[camera]][k]; l++)
	      { XDrawLine(hack_track_display[camera],
			  hack_track_window[camera],
			  hack_track_gc[camera],
			  hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]][k][l-1],
			  hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]][k][l-1],
			  hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]][k][l],
			  hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]][k][l]);}
	      XDrawLine(hack_track_display[camera],
			hack_track_window[camera],
			hack_track_gc[camera],
			hack_track_window_x[camera]+hack_track_polygon_x[camera]
			[hack_track_i[camera]]
			[k]
			[hack_track_polygon_l[camera][hack_track_i[camera]][k]-1],
			hack_track_window_y[camera]+hack_track_polygon_y[camera]
			[hack_track_i[camera]]
			[k]
			[hack_track_polygon_l[camera][hack_track_i[camera]][k]-1],
			hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]][k][0],
			hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]][k][0]);}}
	  XFlush(hack_track_display[camera]);}
	hack_track_i[camera]++;}
      /* Stop capturing when hack_track_i[camera]>=hack_track_n[camera]. */
      else hack_track_l[camera] = 0;}}
  /* hack_track_m[camera] is the viewfinder refresh downsample factor. If
     hack_track_m[camera]==0 then the viewfinder is turned off. If hack_track_m[camera]!=0
     then the viewfinder refresh rate is raw_frame_rate/hack_track_m[camera]. */
  if (hack_track_m[camera]>0)
  /* hack_track_j[camera] does the downsampling for the viewfinder refresh. It counts
     from 0,...,hack_track_m[camera]-1 and cycles. Viewfinder refresh is done when
     hack_track_j[camera]==0. */
  { hack_track_j[camera] = (hack_track_j[camera]+1)%hack_track_m[camera];
    if (hack_track_j[camera]==0)
    /* Display the current video frame. The meteor buffer has four bytes per
       pixel. Depending on the X server, shmimage might have either three or
       four bytes per pixel. If it has four bytes per pixel then use memcpy
       since it is faster. If it has three bytes per pixel then we need to
       roll our own to do packing. */
    { if (hack_track_shmimage[camera]->bits_per_pixel==24)
      { for (p1 = &buffer[0],
	     p2 = &hack_track_shmimage[camera]->data[0],
	     pl = &buffer[hack_track_height[camera]*hack_track_width[camera]*4];
	     p1<pl;)
	{ *p2++ = *p1++;
	  *p2++ = *p1++;
	  *p2++ = *p1++;
	  p1++;}}
      else memcpy(&hack_track_shmimage[camera]->data[0],
		  &buffer[0],
		  hack_track_height[camera]*hack_track_width[camera]*4);
      XShmPutImage(hack_track_display[camera],
		   hack_track_window[camera],
		   hack_track_gc[camera],
		   hack_track_shmimage[camera],
		   0,
		   0,
		   hack_track_window_x[camera],
		   hack_track_window_y[camera],
		   MIN(hack_track_width[camera], hack_track_window_width[camera]),
		   MIN(hack_track_height[camera], hack_track_window_height[camera]),
		   False);
      /* When viewing the ellipses or polygons overlayed on the video
	 (since hack_track_m[camera]>0), draw the ellipses or polygons in white. */
      if (hack_track_tracking_ellipses[camera]||hack_track_tracking_polygons[camera])
      { XSetForeground(hack_track_display[camera], hack_track_gc[camera],
		       XWhitePixel(hack_track_display[camera], hack_track_screen[camera]));
	/* Draw the ellipses. */
	if (hack_track_tracking_ellipses[camera])
	{ for (k = 0; k<gobject_k[camera][hack_track_i[camera]-1]; k++)
	  { hack_track_draw_ellipse(camera,
				    gellipse_x[camera][hack_track_i[camera]-1][k],
				    gellipse_y[camera][hack_track_i[camera]-1][k],
				    gellipse_theta[camera][hack_track_i[camera]-1][k],
				    gellipse_r[camera][hack_track_i[camera]-1][k],
				    gellipse_s[camera][hack_track_i[camera]-1][k]);}}
	/* Draw the polygons. */
	if (hack_track_tracking_polygons[camera])
	{ for (k = 0; k<gobject_k[camera][hack_track_i[camera]-1]; k++)
	  { for (l = 1; l<hack_track_polygon_l[camera][hack_track_i[camera]-1][k]; l++)
	    { XDrawLine(hack_track_display[camera],
			hack_track_window[camera],
			hack_track_gc[camera],
			hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]-1][k][l-1],
			hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]-1][k][l-1],
			hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]-1][k][l],
			hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]-1][k][l]);}
	    XDrawLine(hack_track_display[camera],
		      hack_track_window[camera],
		      hack_track_gc[camera],
		      hack_track_window_x[camera]+hack_track_polygon_x[camera]
		      [hack_track_i[camera]-1]
		      [k]
		      [hack_track_polygon_l[camera][hack_track_i[camera]-1][k]-1],
		      hack_track_window_y[camera]+hack_track_polygon_y[camera]
		      [hack_track_i[camera]-1]
		      [k]
		      [hack_track_polygon_l[camera][hack_track_i[camera]-1][k]-1],
		      hack_track_window_x[camera]+hack_track_polygon_x[camera][hack_track_i[camera]-1][k][0],
		      hack_track_window_y[camera]+hack_track_polygon_y[camera][hack_track_i[camera]-1][k][0]);}}}
      XFlush(hack_track_display[camera]);}}}}

void hack_track_sigaction_multiple(int ncameras)
{ struct sigaction sigact;
  int camera;
  hack_track_ncameras = ncameras;
  sigact.sa_handler = hack_track_handler_multiple;
  sigemptyset(&sigact.sa_mask);
  sigact.sa_flags = SA_RESTART;
  for (camera = 0; camera<ncameras; camera++)
  { if (!hack_track_using_v4l[camera])
    { perror("Can only run multiple cameras with v4l");
      exit(-1);}}
  if (sigaction(SIGALRM, &sigact, NULL))
  { perror("hack_track sigaction failed");
    exit(-1);}}

void hack_track_startup_multiple(int ncameras,
				 int height,
				 int width,
				 int nframes,
				 int subsample,
				 int raw_frame_rate)
{ int camera;
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_using_v4l[camera] = v4l_available(camera);}
  for (camera = 0; camera<ncameras; camera++)
  { if (!hack_track_using_v4l[camera])
    { perror("Can only run multiple cameras with v4l");
      exit(-1);}}
  for (camera = 0; camera<ncameras; camera++) v4l_open_video(camera);
  hack_track_sigaction_multiple(ncameras);
  for (camera = 0; camera<ncameras; camera++)
  { /*
    v4l_restore_factory_settings(camera);
    usleep(1000000);
    */
    v4l_set_agc(camera, -1);
    v4l_set_shutter(camera, -1);
    v4l_set_compression(camera, 3);
    v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
    v4l_set_brightness(camera, 32768);
    v4l_set_contrast(camera, 32768);
    v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
    v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
    v4l_set_whiteness(camera, 32768);
    v4l_set_size(camera, width, height);
    v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
    if (v4l_get_frame_rate(camera)!=raw_frame_rate)
    { fprintf(stderr, "hack_track unsupported frame rate\n");
      exit(-1);}}
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_height[camera] = height;
    hack_track_width[camera] = width;
    hack_track_subsample[camera] = subsample;
    hack_track_malloc(camera, nframes);
    v4l_mmap_frame(camera);
    hack_track_buffer[camera] = v4l_converted_frame[camera];
    hack_track_display[camera] = NULL;}
  for (camera = 0; camera<ncameras; camera++) v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_startup_with_viewfinder_multiple(int ncameras,
						 int height,
						 int width,
						 int nframes,
						 int subsample,
						 Display *display,
						 int screen,
						 Window window,
						 int window_x[NCAMERAS],
						 int window_y[NCAMERAS],
						 int window_width,
						 int window_height,
						 int raw_frame_rate)
{ int camera;
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_using_v4l[camera] = v4l_available(camera);}
  for (camera = 0; camera<ncameras; camera++)
  { if (!hack_track_using_v4l[camera])
    { perror("Can only run multiple cameras with v4l");
      exit(-1);}}
  for (camera = 0; camera<ncameras; camera++) v4l_open_video(camera);
  hack_track_sigaction_multiple(ncameras);
  for (camera = 0; camera<ncameras; camera++)
  { /*
    v4l_restore_factory_settings(camera);
    usleep(1000000);
    */
    v4l_set_agc(camera, -1);
    v4l_set_shutter(camera, -1);
    v4l_set_compression(camera, 3);
    v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
    v4l_set_brightness(camera, 32768);
    v4l_set_contrast(camera, 32768);
    v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
    v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
    v4l_set_whiteness(camera, 32768);
    v4l_set_size(camera, width, height);
    v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
    if (v4l_get_frame_rate(camera)!=raw_frame_rate)
    { fprintf(stderr, "hack_track unsupported frame rate\n");
      exit(-1);}}
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_height[camera] = height;
    hack_track_width[camera] = width;
    hack_track_subsample[camera] = subsample;
    hack_track_malloc(camera, nframes);
    v4l_mmap_frame(camera);
    hack_track_buffer[camera] = v4l_converted_frame[camera];
    hack_track_attach_viewfinder(camera,
				 display,
				 screen,
				 window,
				 window_x[camera],
				 window_y[camera],
				 window_width,
				 window_height);}
  for (camera = 0; camera<ncameras; camera++) v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_restartup_multiple(int ncameras,
				   int height,
				   int width,
				   int nframes,
				   int subsample,
				   int raw_frame_rate)
{ int camera;
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_l[camera] = 0;
    hack_track_m[camera] = 0;
    if (!hack_track_using_v4l[camera])
    { perror("Can only run multiple cameras with v4l");
      exit(-1);}}
  v4l_interrupt_off();
  for (camera = 0; camera<ncameras; camera++)
  { if (hack_track_display[camera]!=NULL) hack_track_detach_viewfinder(camera);
    v4l_munmap_frame(camera);
    hack_track_free(camera);
    v4l_close_video(camera);
    if (hack_track_display[camera]!=NULL)
    XClearArea(hack_track_display[camera],
	       hack_track_window[camera],
	       hack_track_window_x[camera],
	       hack_track_window_y[camera],
	       hack_track_width[camera],
	       hack_track_height[camera],
	       False);}
  for (camera = 0; camera<ncameras; camera++)
  { v4l_open_video(camera);
    /*
    v4l_restore_factory_settings(camera);
    usleep(1000000);
    */
    v4l_set_agc(camera, -1);
    v4l_set_shutter(camera, -1);
    v4l_set_compression(camera, 3);
    v4l_set_palette(camera, VIDEO_PALETTE_YUV420P, 16);
    v4l_set_brightness(camera, 32768);
    v4l_set_contrast(camera, 32768);
    v4l_set_hue(camera, 65535);	/* not implemented on Philips 690 Webcam */
    v4l_set_colour(camera, 65535); /* not implemented on Philips 690 Webcam */
    v4l_set_whiteness(camera, 32768);
    v4l_set_size(camera, width, height);
    v4l_set_frame_rate(camera, raw_frame_rate, FALSE);
    if (v4l_get_frame_rate(camera)!=raw_frame_rate)
    { fprintf(stderr, "hack_track unsupported frame rate\n");
      exit(-1);}}
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_height[camera] = height;
    hack_track_width[camera] = width;
    hack_track_subsample[camera] = subsample;
    hack_track_malloc(camera, nframes);
    v4l_mmap_frame(camera);
    hack_track_buffer[camera] = v4l_converted_frame[camera];
    if (hack_track_display[camera]!=NULL)
    { hack_track_attach_viewfinder(camera,
				   hack_track_display[camera],
				   hack_track_screen[camera],
				   hack_track_window[camera],
				   hack_track_window_x[camera],
				   hack_track_window_y[camera],
				   hack_track_window_width[camera],
				   hack_track_window_height[camera]);}}
  for (camera = 0; camera<ncameras; camera++) v4l_mmap_capture(camera, 0);
  v4l_interrupt_on(raw_frame_rate);}

void hack_track_shutdown_multiple(int ncameras)
{ int camera;
  for (camera = 0; camera<ncameras; camera++)
  { hack_track_l[camera] = 0;
    hack_track_m[camera] = 0;
    if (!hack_track_using_v4l[camera])
    { perror("Can only run multiple cameras with v4l");
      exit(-1);}}
  v4l_interrupt_off();
  for (camera = 0; camera<ncameras; camera++)
  { if (hack_track_display[camera]!=NULL) hack_track_detach_viewfinder(camera);
    v4l_munmap_frame(camera);
    hack_track_free(camera);
    v4l_close_video(camera);}
  hack_track_set_nonreal_time();}

/* Tam V'Nishlam Shevah L'El Borei Olam */
